'.----------+----------+---------- [Board] ---------+---------------------:
'|                         Board System v1.00 by TuS                      |
':----------+----------+----------+-----------------+---------------------:

'**************************************************************************
'* Copyright (C) 2011                                                     *
'* TuS, tustus[at]hotmail[dot]com                                         *
'*                                                                        *
'* This program is free software; you can redistribute it and/or modify   *
'* it under the terms of the GNU General Public License as published by   *
'* the Free Software Foundation; either version 2 of the License, or      *
'* (at your option) any later version.                                    *
'*                                                                        *
'* This program is distributed in the hope that it will be useful, but    *
'* WITHOUT ANY WARRANTY; without even the implied warranty of             *
'* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                   *
'* See the GNU General Public License for more details.                   *
'*                                                                        *
'* You should have received a copy of the GNU General Public License      *
'* along with this program; if not, write to the                          *
'* Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,    *
'* MA 02111-1307 USA                                                      *
'**************************************************************************
'**************************************************************************
'* VBS Script logging Framework :                                         *
'* Copyright (C) 2006                                                     *
'* Christer Finsen, mind[underscore]trip[at]users[dot]sourceforge[dot]net *
'* Nils-Erik Aurker, nils-erik[at]users[dot]sourceforge[dot]net          *
'**************************************************************************

Option Explicit 

'Import Configuration
Import ("Board.Config")

'Make sure constants in message.config are correctlly defined
If TypeName(RAIDENFTPD_PATH) <> "String" _
	Or TypeName(BOARD_LIST_OPS_ONLY) <> "Boolean" _
	Or TypeName(BOARD_DETAILS_OPS_ONLY) <> "Boolean" _
	Or TypeName(USER_LIST_OWN_BOARD_ONLY) <> "Boolean" _
	Or TypeName(DELETE_OPS_ONLY) <> "Boolean" _
	Or TypeName(DELETE_OWN_ONLY) <> "Boolean" _	
	Or TypeName(ALLOWED_BOARDS) <> "String" _
	Or TypeName(MESSAGE_ACEND_ORDER) <> "Boolean" _		
	Or TypeName(MESSAGE_DISPLAY_LIMIT) <> "Integer" _
	Or TypeName(MESSAGE_STORE_LIMIT) <> "Integer" _
	Or TypeName(ADDON_ENABLE_NOTIFICATION) <> "Boolean" _
	Or TypeName(ADDON_MESSAGE_PATH) <> "String" _	
	Or TypeName(SCENEVIEW) <> "Boolean" _
	Or TypeName(WIDTH) <> "Integer" _
	Or TypeName(SCENEHEADER) <> "String" _
	Or TypeName(SCENESEPARATOR) <> "String" _
	Or TypeName(SCENETAIL) <> "String" _
	Or TypeName(NORMALHEADER) <> "String" _
	Or TypeName(EVENTLOG) <> "Integer" _
	Or TypeName(FILELOG) <> "Integer" _
	Or TypeName(NUMBEROFLOGS) <> "Integer" Then
	WScript.echo "One or more required constants is not defined. Please see " _
	& "Message_Readme.txt for installation"
	WScript.quit
End If

'*********************************************************************************
'*********************************************************************************
'       DO NOT CHANGE THESE CONSTANTS UNLESS YOU KNOW WHAT YOU ARE DOING
'*********************************************************************************
Const APPNAME       = "TuS Board System"
Const APPVERMAJOR   = "1"
Const APPVERMINOR   = "00"
Const AUTHOR        = "TuS"
Const COPYYEAR      = "2011"
Const FORREADING    = 1
Const FORWRITING    = 2
Const FORAPPENDING  = 8
Const SUCCESS       = 0
Const ERRORL        = 1
Const WARNING       = 2
Const INFORMATION   = 4
Const ABORT         = "Script aborted with error(s). To determine cause, see logged information"
Const SITECMD       = "board"
'*********************************************************************************
'Script Root folder
Dim SCRIPTPATH : SCRIPTPATH = Left(WScript.ScriptFullName, InStrRev(WScript.ScriptFullName,"\")-1)
Dim SCRIPTNAME : SCRIPTNAME = Left(WScript.ScriptName, InStrRev(WScript.ScriptName,".")-1)
'012345678901234567890123456789012345678901234567890123456789012345678901234567891
'Script Default parameters
Dim DEF_BOARD  : DEF_BOARD  = "*"
Dim DEF_MESSAGE_DISPLAY_LIMIT  : DEF_MESSAGE_DISPLAY_LIMIT  =  MESSAGE_DISPLAY_LIMIT
'#################################################################################
'	Main Entry Point
'#################################################################################
Dim iCnt, iCnt2
Dim cmdGCID,cmdLEVEL,cmdSERVER,cmdUSER,cmdUSERGroup,cmdSITECMD,cmdCMD,cmdOPTIONS
Dim oArgs : Set oArgs = WScript.Arguments

Dim currentSub : currentSub = "Main Code"
Dim tStartTime,tEndTime

'Debug Class level Events
Const DEBUG_CLASS_EVENTS = False
Const FIRE_CLASS_EVENTS  = False

tStartTime = Timer()

'#-------------------------------------------------------------------------------#
'Load the framwork
'#-------------------------------------------------------------------------------#
'Init the Logger
Dim UserLog : Set UserLog = New UserLogClass

'Init the Helper
Dim Helper : Set Helper = New HelperClass

'start the logger
UserLog.Start
'#-------------------------------------------------------------------------------#

UserLog.LogEvent SUCCESS, "*** " & APPNAME & " " & APPVERMAJOR & "." & APPVERMINOR & " by " & AUTHOR & " ***"
UserLog.LogEvent SUCCESS, APPNAME & " Ver." & APPVERMAJOR & "." & APPVERMINOR & " Copyright(C) " & COPYYEAR
UserLog.LogEvent SUCCESS, APPNAME & " Ver." & APPVERMAJOR & "." & APPVERMINOR & " comes with ABSOLUTELY NO WARRANTY;"
UserLog.LogEvent SUCCESS, "This is free software, and you are welcome to redistribute it under certain" 
UserLog.LogEvent SUCCESS, "conditions; Read License.txt for details." 
UserLog.LogEvent SUCCESS, "VBS Script logging Framework: Copyright(C) 2006 Christer Finsen,and Nils-Erik Aurker" 
UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"

UserLog.LogEvent INFORMATION, "[" & currentSub & "] Collecting Script Arguments"
UserLog.LogEvent INFORMATION, "[" & currentSub & "] Number of Arguments : " & oArgs.Count

'Init the command Processor
Dim CmdProcessor : Set CmdProcessor = New CmdProcessorClass

'Init the Classes
Dim RaidenUserFile : Set RaidenUserFile = New RaidenUserFileClass
Dim RaidenOutFile : Set RaidenOutFile = New RaidenOutFileClass
Dim RaidenBoardStoreFile : Set RaidenBoardStoreFile	= New RaidenBoardStoreFileClass

'Simple verification that the FTPD process is initiating the command in a way we expect
If oArgs.Count < 5 Then
	UserLog.LogEvent ERRORL, "[" & currentSub & "] FTPD or this installation has been tampered with. This command needs at least FIVE arguments to run"
	WScript.Quit
End If

'Assign Main Parameters
For iCnt = 0 To oArgs.Count -1 
	UserLog.LogEvent INFORMATION, "[" & currentSub & "] Argument#" & iCnt+1 & ", Value=" & oArgs(iCnt)
	
	Select Case iCnt
		Case 0
		cmdGCID = oArgs(iCnt)
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] GCID=" & cmdGCID
		Case 1
		cmdLEVEL = oArgs(iCnt)
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] LEVEL=" & cmdLEVEL
		Case 2
		cmdSERVER = oArgs(iCnt)
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] SERVER=" & cmdSERVER
		Case 3
		cmdUSER = oArgs(iCnt)
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] USER=" & cmdUSER
		Case 4
		cmdUSERGroup = oArgs(iCnt)
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] USERGroup=" & cmdUSERGroup
		Case 5
		cmdSITECMD = oArgs(iCnt)
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] SITECOMMAND=" & cmdSITECMD
		Case 6
		cmdCMD = oArgs(iCnt)
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] COMMAND=" & cmdCMD
		Case 7
		'get the options if any	
		Dim IOptionStart : IOptionStart = 7
		ReDim cmdOPTIONS(oArgs.Count - iCnt - 1)
		For iCnt2 = 0 To (oArgs.Count - iCnt - 1)
			cmdOPTIONS(iCnt2) = oArgs(iCnt + iCnt2)
		Next
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] OPTIONS=" & Join(cmdOPTIONS," ")
	End Select
Next	

' Assign Class Properties (This is the working Context)
'#-------------------------------------------------------------------------------#
RaidenOutFile.GCID 			    = cmdGCID
RaidenOutFile.Server		    = cmdSERVER
RaidenOutFile.Path			    = RAIDENFTPD_PATH
RaidenOutFile.SceneView 	    = SCENEVIEW
RaidenOutFile.Width			    = WIDTH

RaidenBoardStoreFile.Server 	= cmdSERVER
RaidenBoardStoreFile.User		= cmdUSER
RaidenBoardStoreFile.UserGroup	= cmdUSERGroup
RaidenBoardStoreFile.Path		= SCRIPTPATH & "\Store"
RaidenBoardStoreFile.StoreLimit = MESSAGE_STORE_LIMIT

RaidenUserFile.Server		    = cmdSERVER
RaidenUserFile.Path			    = RAIDENFTPD_PATH
'#-------------------------------------------------------------------------------#

'load the users and groups
RaidenUserFile.Load

'Dispatch the command
If RaidenUserFile.Loaded Then 
	CmdProcessor.CommandDispatcher
Else
    CmdProcessor.TerminateInSysErr
End If 

UserLog.LogEvent SUCCESS, "[Main Code] " & APPNAME & " " & APPVERMAJOR & "." & APPVERMINOR & " Completed"
UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"

'#################################################################################
'	Main Exit Point
'#################################################################################

'#################################################################################
' Class Wrapper for RaidenFTPD File
'#################################################################################
Class RaidenUserFileClass
	'Class vars
	Private	aUsers, aGroups, c_sServer,c_sPath, c_sUserFile, c_bLoaded, c_iUserCount, c_iGroupCount
	Private oFso,oFile,oUserFile
	
	'Function vars
	Private sUserFilePath, sData, sUserLine, sUserList, sUser, sExistingUser, sGroup,sCurrentGroup, sGroupCurrentUsers
    Private	bFileExists, bFound
	Public aVFSData, aUserInfo, aUserGroups, aCurrentGroups, aCurrentUsers, sGroupPath, aTmpGroups
	Private iIndex, iCnt, element, iResult
	
	'#---------------------------------------------------------------------------#
	Private Sub Class_Initialize
		c_bLoaded		= False
		c_iUserCount    = 0
		c_iGroupCount   = 0
		c_sPath		 	= vbNullString 
		c_sUserFile		= vbNullString
		oUserFile		= Null
		Set aUsers 		= New ArrayWrapper
		aUsers.oType	= "USERS"
		aUsers.Parent	= me
		Set aGroups		= New ArrayWrapper
		aGroups.oType	= "GROUPS"
		aGroups.Parent	= me
		Set oFso		= CreateObject("Scripting.FileSystemObject")
	End Sub

	Private Sub Class_Terminate
		Set aUsers 		= Nothing
		Set aGroups		= Nothing
		Set oFso		= Nothing
		Set oUserFile	= Nothing
	End Sub
	
	Public Sub Class_Event(sSource, sEventType, ByVal bResult,ByVal values)
		'********************************************************************************
		' Purpose : Fire an event received from the child objects
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenMsgStoreFile:Class_Event"
		
		If IsArray(values) Then
			values = Join(values,"|")
		End If 
		
		If (TypeName(DEBUG_CLASS_EVENTS) <> "Nothing") Then
			If (DEBUG_CLASS_EVENTS = True) Then
				WScript.Echo "EVENT FIRED [" & currentSub & "] source: " & sSource & " ; EventType:" & sEventType & " ; Result:" & bResult & " ; values:" & values
			End If
		End If 
	End Sub
	
	'#---------------------------------------------------------------------------#
	Public Property Get Loaded()
	Loaded = c_bLoaded
	End Property
	
	Private Property Let Loaded(bLoaded)
	If (VarType(bLoaded) = vbBoolean) Then
		c_bLoaded = bLoaded
	End If 
	End Property
	
	Public Property Get Path()
	Path = c_sPath
	End Property
	
	Public Property Let Path(sPath)
	If sPath <> vbNullString Then
		c_sPath = sPath
	End If 
	End Property
	
	Public Property Get UserCount()
		UserCount = c_iUserCount
	End Property
	
	Private Property Let UserCount(iUserCount)
	If (VarType(iUserCount) = vbInteger) Then
		c_iUserCount = iUserCount
	End If 
	End Property
	
	Public Property Get GroupCount()
	GroupCount = c_iGroupCount
	End Property
	
	Private Property Let GroupCount(iGroupCount)
	If (VarType(iGroupCount) = vbInteger) Then
		c_iGroupCount = iGroupCount
	End If 
	End Property
	
	Public Property Get Users()
	Set Users = aUsers
	End Property
	
	Public Property Get Groups()
	Set Groups = aGroups
	End Property
	
	Public Property Get Server()
	Server = c_sServer
	End Property
	
	Public Property Get UserFile()
	UserFile = c_sUserFile
	End Property
	
	Private Property Let UserFile(sUserFile)
	If (VarType(sUserFile) = vbString) Then
		c_sUserFile = sUserFile
	End If 
	End Property
	
	Public Property Let Server(sServer)
	If (VarType(sServer) = vbString) Then
		c_sServer = sServer
	End If 
	End Property
	'#---------------------------------------------------------------------------#
	
	Public Function Load()
		'**********************************************************************************
		' Puropose : load in memory the Raiden user File
		' Input    : None
		'**********************************************************************************
		Dim currentSub : currentSub = "Class RaidenUserFile:Load"
		
		'Init vars
		c_sUserFile	= c_sPath & "\" & c_sServer & ".user"
		c_bLoaded 	= False
		bFileExists = False
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Load UserFile: " & c_sUserFile & " Started."
		
		'check that file exists
		bFileExists = Helper.FileExists(c_sUserFile, True)
		
		'Open User file
		Set oUserFile = oFso.OpenTextFile(UserFile, FORREADING)
		
		If Err.number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to read UserFile: " & c_sUserFile & ". The error was: " & Err.description & " (" & Err.number & ")"
			CmdProcessor.TerminateInSysErr
		Else
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] UserFile: " & c_sUserFile & " was successfully opened for read."
		End If
		
		'Read User File stream
		Do While Not oUserFile.AtEndOfStream
			sData = oUserFile.ReadALL
		Loop
		oUserFile.close
		
		If (Not IsEmpty(sData)) Then
			'split the records in individual lines
			aVFSData = Split(sData,vbCrLf)
			
			For Each sUserLine In (aVFSData)
				aUserInfo = Split(sUserLine,":")
				If (IsArray(aUserInfo) And (UBound(aUserInfo) = 22) )Then
					UserLog.LogEvent INFORMATION, "[" & currentSub & "] Processing UserLine: " & sUserLine
					'store User and group in the User Array
					Users.AddItem(Array(aUserInfo(0),aUserInfo(3))) 
					
					'check if the group allready exist in the group array
					aUserGroups = Split(aUserInfo(3),",")
					For Each sGroup In (aUserGroups)
						iIndex = Groups.GetIndexByValue(sGroup)
						If iIndex <> -1 Then 
							sGroupCurrentUsers = GetGroupUsers(sGroup)
							Groups.UpdateItem iIndex,Array(sGroup,Join(sGroupCurrentUsers,",") & "," & aUserInfo(0)) 
						Else
							Groups.AddItem (Array(sGroup,aUserInfo(0)))
						End If
					Next
				End If
				Helper.EchoErr Err, currentSub
			Next

			'Update the class vars
			UserCount	= Users.Size
			GroupCount	= Groups.Size
			Loaded = True
		End If
		
		BubbleSort Users.Data
		BubbleSort Groups.Data
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] UserFile: " & UserFile & " successfully read and loaded."
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] UserFile: loaded - Users:" & c_iUserCount & "/Groups:" & c_iGroupCount
	End Function
	
	Private Function BubbleSort(byRef list)
    'Its a sorting procedure for 1-dimensional arrays named List
    'The procedure takes each array element, if it is greater than the next element, the two elements swap positions.
    'The evaluation is repeated for every pair of items (that is n-1 times)
    'Change data type to As Integer if your array isnt text
     Dim First, Last
     Dim i, j 
     Dim temp 
	 First = LBound(list)
     Last = UBound(list)
	     For i = First To (Last-1)
	         For j = i + 1 To Last
	             If list(i)(0) > list(j)(0) Then
	                 temp = list(j)
	                 list(j) = list(i)
	                 list(i) = temp
	             End If
	         Next
	     Next
 	End Function
	
	Public Function GetGroupUsers(sGroup)
		'**********************************************************************************
		' Purpose : This function loops the array and returns the index depending on wether
		'           or not a string exists as one of the values within the array. 
		' Inputs	: string	: sGroup	: the group to check
		' Return	: array		: the array of users
		'**********************************************************************************
		Dim currentSub : currentSub = "Class RaidenUserFile:GetGroupUsers" 
		
		'Init vars
		sUserList = vbNullString
		
		If IsArray(Groups.Data) Then
			element 	= Groups.GetItemByValue(sGroup)
			sUserList 	= element(1)
		End If
		
		If (sUserList <> vbNullString) Then	
			GetGroupUsers = Split(sUserList,",")
		Else 
			GetGroupUsers = Array()
		End If 
	End Function
	
	Private Function GetFilteredUsersForGroups(aGroups)
		'**********************************************************************************
		' Purpose : Return a filtered user list based on the groups array provided
		' Inputs	: array		: aGroups	: the groups to check
		' Return	: array		: the array of users
		'**********************************************************************************
		Dim currentSub : currentSub = "Class RaidenUserFile:GetGroupUsers" 
		
		'Init vars
		sUserList 	= vbNullString
		bFound 		= False 
		Set element = 	Nothing
		
		If IsArray(Groups.Data) Then
			For Each sGroup In (aGroups)
				element = Groups.GetItemByValue(sGroup)
				
				If (sUserList = vbNullString) Then
					sUserList = element(1)
				Else
					For Each sUser In Split(element(1),",")
						For Each sExistingUser In Split(sUserList,",")
							If LCase(sExistingUser) = LCase(sUser)Then
								bFound = True
								Exit For
							End If 
						Next
						If (bFound = False) Then
							sUserList = sUserList & "," & sUser
						End If 
						bFound = False
					Next
				End If
			Next
		End If
		
		If (sUserList <> vbNullString) Then	
			GetFilteredUsersForGroups = Split(sUserList,",")
		Else 
			GetFilteredUsersForGroups = Array()
		End If 
	End Function
	
	Public Function GetUserGroups(sUser)
		'**********************************************************************************
		' Purpose 	: Return the user groups for a given user. 
		' Inputs	: string	: sUser	: the user to check
		' Return	: array		: the array of Groups
		'**********************************************************************************
		Dim currentSub : currentSub = "Class RaidenUserFile:GetUserGroups" 
		
		If IsArray(Users.Data) Then
			For Each element In Users.Data
				If (LCase(sUser) = LCase(element(0))) Then
					aCurrentGroups = Split(element(1), ",")
					Exit For
				End If
			Next
		End If
		
		If (Helper.GetSize(aCurrentGroups) <> 0) Then
			GetUserGroups = aCurrentGroups
		Else
			GetUserGroups = Array()
		End If 
	End Function
	
	Function ValidateUser(sDestUser)
		'********************************************************************************
		' Purpose : Validate a user based on the FTPD User File
		' Input   : string 	: sDestUser: The user name to validate
		' Return  : integer : the index of the User (0 to x) or -1 if not found
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenUserFile:ValidateUser" 

		'set the default value
		iResult 	= -1
		
		If (Not IsEmpty(Users)) Then
			iResult = Users.GetIndexByValue(sDestUser)
			If (iResult <> -1) Then
				ValidateUser = iResult
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] User " & sDestUser & " Is valid"
			Else
				ValidateUser = -1
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] User " & sDestUser & " Is NOT Valid"
			End If
		End If
	End Function
	
	Function GetAllUsers()
		'********************************************************************************
		' Purpose : Return the all the users based on the FTPD User File
		' Return  : array : the array of users
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenUserFile:GetAllUsers" 
		
		If (Not IsEmpty(Users.Data)) Then
			For Each element In Users.Data
				If (Helper.GetSize(aCurrentUsers) <> 0) Then
					ReDim Preserve aCurrentUsers(UBound(aCurrentUsers)+1)
				Else 
					ReDim aCurrentUsers(0)
				End If
				aCurrentUsers(UBound(aCurrentUsers)) = element(0)
			Next
		End If
		GetAllUsers = aCurrentUsers
	End Function
	
	Function GetAllGroups()
		'********************************************************************************
		' Purpose : Return all the Groups based on the FTPD User File
		' Return  : array : the array of groups
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenUserFile:GetAllGroups" 
		
		
		'Reset and reload
		aCurrentGroups = Empty
				
		If (Not IsEmpty(Groups.Data)) Then
			For Each element In Groups.Data
				If (Helper.GetSize(aCurrentGroups) <> 0) Then
					ReDim Preserve aCurrentGroups(UBound(aCurrentGroups)+1)
				Else 
					ReDim aCurrentGroups(0)
				End If
				aCurrentGroups(UBound(aCurrentGroups)) = element(0)
			Next
		End If
		
		GetAllGroups = aCurrentGroups
	End Function
	
	Public Function GetFilteredGroups (sUser,bFilter)
		'********************************************************************************
		' Purpose : Return a Group array based on the FTPD User File
		' Input   : String 	: sUser		: The UserName requesting the list
		'			Boolean	: bFilter	: Filter criteria true:apply filter | False: do not apply Filter
		' Return  : Array	: the array if found or empty Array if not found
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenUserFile:GetFilteredGroups" 
		
		'Get the current user Groups
		If (bFilter) Then
			aCurrentGroups  = GetUserGroups(sUser)
		Else
			aCurrentGroups 	= GetAllGroups()
		End If
		
		If (Helper.GetSize(aCurrentGroups) <> 0) Then
			GetFilteredGroups = aCurrentGroups
		Else 
			GetFilteredGroups = Array()
		End If
	End Function
	
	Public Function GetFilteredUsers (sUser,bFilter)
		'********************************************************************************
		' Purpose : Return a User array based on the FTPD User File
		' Input   : String 	: sUser		: The UserName requesting the list
		'			Boolean	: bFilter	: Filter criteria true:apply filter | False: do not apply Filter
		' Return  : Array	: the array if found or empty Array if not found
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenUserFile:GetFilteredUsers" 
		
		'Get the current user Groups
		If (bFilter) Then
			aCurrentGroups = GetFilteredGroups(sUser,bFilter)
		Else
			aCurrentGroups = GetAllGroups()
		End If
		
		aCurrentUsers = GetFilteredUsersForGroups(aCurrentGroups)
		
		If (Helper.GetSize(aCurrentUsers) <> 0) Then
			GetFilteredUsers = aCurrentUsers
		Else 
			GetFilteredUsers = Array()
		End If
	End Function
	
	Public Function CheckUserGroup (sUser,sGroup)
		'********************************************************************************
		' Purpose : Check if user is part of a group
		' Input   : String 	: sUser		: The UserName
		'			String 	: sGroup	: The UserGroup
		' Return  : bool	: true or False
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenUserFile:CheckUserGroup" 
		Dim bFound : bFound = false
		
		'Get the current user Groups
		aCurrentGroups = GetFilteredGroups(sUser,true)
		
		For Each sCurrentGroup In aCurrentGroups
			If LCase(sCurrentGroup) = LCase(sGroup) Then
				bFound = true
				Exit For
			End If 
		
		Next
		
		CheckUserGroup = bFound
		
	End Function
	
	Function ValidateGroup(sDestGroup)
		'********************************************************************************
		' Purpose : Validate a Group based on the FTPD User File
		' Input   : string 	: sDestGroup: The Group name to validate
		' Return  : integer	: the index of the Group (0 to x) or -1 if not found
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenUserFile:ValidateGroup" 
		
		'set the default value
		iResult 	= -1
		
		If (Not IsEmpty(Groups)) Then
			iResult = Groups.GetIndexByValue(sDestGroup)
			If (iResult <> -1) Then
				ValidateGroup = iResult
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Group " & sDestGroup & " Is valid"
			Else
				ValidateGroup = -1
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Group " & sDestGroup & " Is NOT valid"
			End If
		End If
	End Function
	
	Function GetRealUserName(sDestUser)
		'********************************************************************************
		' Purpose : Return the real userName based on the FTPD User File
		' Input   : string 	: sDestUser: The user name to retrieve
		' Return  : string	: the Formated UserName or vbNullString if not found
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenUserFile:GetRealUserName" 
		
		'set the default value
		GetRealUserName = vbNullString
		
		If (Not IsEmpty(Users)) Then
			element = Users.GetItemByValue(sDestUser)
			If IsArray(element) Then
				GetRealUserName = element(0)
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Real User Name is :" & GetRealUserName
			Else 
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] User " & sDestUser & " Is NOT Valid"
			End If 
		End If
	End Function
	
	Function GetRealGroupName(sDestGroup)
		'********************************************************************************
		' Purpose : Return the real GroupName based on the FTPD User File
		' Input   : string 	: sDestGroup: The Group name to retrieve
		' Return  : string	: the Formated GroupName or vbNullString if not found
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenUserFile:GetRealGroupName" 
		
		'set the default value
		GetRealGroupName = vbNullString
		
		If (Not IsEmpty(Groups)) Then
			element = Groups.GetItemByValue(sDestGroup)
			If IsArray(element) Then
				GetRealGroupName = element(0)
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Real Group Name is :" & GetRealGroupName
			Else 
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Group " & sDestGroup & " Is NOT Valid"
			End If 
		End If
	End Function
End Class

'######################################################################################
' Class Wrapper for RaidenFTPD BOARD Store File
'######################################################################################
Class RaidenBoardStoreFileClass
	
	'Class vars
	Private c_sServer, c_sUser, c_sUserGroup, c_bOutputResult, c_sFilePath, c_aItems, c_iItemCount, c_iNewItemCount, c_iStoreLimit
	
	'Local vars
	Private	oFso, oFile
	Private iItemCnt, iNewItemCnt
	Private	sLine, sUserFile, sElement, sTime, sMessage, aMessage
	Private	bLoaded, bSaved, bUserFileExists, bIsNew 
	Private tTime

	'#---------------------------------------------------------------------------#
	Private Sub Class_Initialize
		c_bOutputResult		= False
		c_sFilePath 		= vbNullString
		c_sUser 			= vbNullString
		c_sUserGroup 		= vbNullString
		c_sServer 			= vbnullstring
		c_iItemCount		= 0
		c_iNewItemCount	    = 0
		c_iStoreLimit       = 25
		bLoaded				= False
		bSaved				= False
		Set c_aItems    	= New ArrayWrapper
		c_aItems.oType	    = "MESSAGES"
		c_aItems.Parent     = me
		Set oFile	        = Nothing
		Set oFso			= CreateObject("Scripting.FileSystemObject")
		sUserFile			= vbNullString
		
	End Sub
	
	Private Sub Class_Terminate
		Set oFso			= Nothing
		Set oFile           = Nothing
		Set c_aItems		= Nothing
	End Sub
	
	Public Sub Class_Event(sSource, sEventType, ByVal bResult, ByVal values)
		'********************************************************************************
		' Purpose : Fire an event received from the child objects
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenStoreFile:Class_Event"
		
		If IsArray(values) Then
			values = Join(values,"|")
		End If 
		
		If (TypeName(DEBUG_CLASS_EVENTS) <> "Nothing") Then
			If (DEBUG_CLASS_EVENTS = True) Then
				WScript.Echo "EVENT FIRED [" & currentSub & "] source: " & sSource & " ; EventType:" & sEventType & " ; Result:" & bResult & " ; values:" & values
			End If
		End If 
	End Sub
	'#---------------------------------------------------------------------------#
	
	Public Property Get Path()
		Path = c_sFilePath
	End Property
	
	Public Property Let Path(sScriptPath)
		If sScriptPath <> vbNullString Then
			c_sFilePath = sScriptPath
		End If 
	End Property
	
	Public Property Get Loaded()
		Loaded = bLoaded
	End Property
	
	Public Property Get Saved()
		Saved = bSaved
	End Property
	
	Public Property Get Server()
		Server = c_sServer
	End Property
	
	Public Property Let Server(sServer)
		If (VarType(sServer) = vbString) Then
			c_sServer = sServer
		End If 
	End Property
	
	Public Property Get User()
		User = c_sUser
	End Property
	
	Public Property Let User(sUser)
		If (VarType(sUser) = vbString) Then
			c_sUser = sUser
		End If 
	End Property
	
	Public Property Get UserGroup()
		UserGroup = c_sUserGroup
	End Property
	
	Public Property Let UserGroup(sUserGroup)
		If (VarType(sUserGroup) = vbString) Then
			c_sUserGroup = sUserGroup
		End If
	End Property 
	
	Public Property Get ItemCount()
		ItemCount = c_iItemCount
	End Property
	
	Public Property Get NewItemCount()
		NewItemCount = c_iNewItemCount
	End Property
	
	Public Property Get Items()
		Set Items = c_aItems
	End Property
	
	Public Property Get StoreLimit()
		Set StoreLimit = c_iStoreLimit
	End Property
	
	Public Property Let StoreLimit(iStoreLimit)
		If (VarType(iStoreLimit) = vbInteger) Then
			c_iStoreLimit = iStoreLimit
		End If
	End Property  
	'#---------------------------------------------------------------------------#
	
	Public Sub load()
		'********************************************************************************
		' Purpose : Create an FTPD Message store as an object oOut
		' Input   : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenStoreFile:load"
		
		'On Error Resume Next
		
		'Reset the MsgStoreFile
		Set oFile 	       = Nothing
		Items.clear
		sLine				= vbNullString
		iItemCnt 			= 0
		
		Helper.CreateFolder(c_sFilePath)
		sUserFile = c_sFilePath & "\" & c_sServer & "-" & c_sUserGroup & ".dat"
		bUserFileExists = Helper.FileExists(sUserFile, False)
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Destination Board file: " & sUserFile & " Exists: " & bUserFileExists	
		
		If (bUserFileExists = False) Then
			Set oFile = oFso.CreateTextFile(sUserFile, True)
			If Err.number <> 0 Then
				UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to create Board file: " & sUserFile & " The error was : " & Err.description & " (" & Err.number & ")"
				CmdProcessor.TerminateInSysErr
			Else
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Board File: " & sUserFile & " was successfully created."
			End If
		End If
		
		Set oFile = oFso.OpenTextFile(sUserFile, FORREADING)
		If Err.number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to open Board file: " & sUserFile & " The error was : " & Err.description & " (" & Err.number & ")"
			CmdProcessor.TerminateInSysErr
		Else
			UserLog.LogEvent SUCCESS, "[" & currentSub & "] Board file: " & sUserFile & " was successfully opened for read."
		End If
		
		'Read User Message file, parsing lines
		Do Until oFile.AtEndOfStream
			aMessage 	= Split(oFile.ReadLine,Chr(127))
			If Helper.GetSize(aMessage) = 4 Then
				c_aItems.AddItem aMessage
				iItemCnt = iItemCnt + 1
				If (aMessage(0) = "1") Then
					iNewItemCnt 	= iNewItemCnt + 1
				End If 
			End If
		Loop
		oFile.close()
		
		c_iItemCount 	= iItemCnt
		c_iNewItemCount = iNewItemCnt
		
		'set the class status
		bLoaded = True
		bSaved 	= True
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] Board file: Found " & iItemCnt & " items."
	End Sub
	
	Private Sub Save()
		'********************************************************************************
		' Purpose : save an FTPD Message store
		' Input   : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenStoreFile:Save"
		
		On Error Goto 0
		
		'Reset the MsgStoreFile
		Set oFile 	        = Nothing
		Set aMessage		= Nothing
		sUserFile			= vbNullString
		iItemCnt 			= 0
		iNewItemCnt 		= 0
		
		Helper.CreateFolder(c_sFilePath)
		sUserFile = c_sFilePath & "\" & c_sServer & "-" & c_sUserGroup & ".dat"
		
		Set oFile = oFso.CreateTextFile(sUserFile, True)
		If Err.number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to create Board store file: " & sUserFile & " The error was : " & Err.description & " (" & Err.number & ")"
			CmdProcessor.TerminateInSysErr
		Else
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] File: " & sUserFile & " was successfully created."
		End If
		
		'Read Local Message array and write to file
		For Each aMessage In Items.Data
			'check the New Message status
			If (aMessage(0) = "1") Then
				iNewItemCnt = iNewItemCnt + 1
			End If	
						
			If c_iItemCount - c_iStoreLimit - iItemCnt <= 0 then
				oFile.WriteLine Join(aMessage,Chr(127))
			End If 
			iItemCnt = iItemCnt + 1
		Next
		oFile.close()
		
		c_iItemCount 	= iItemCnt
		c_iNewItemCount = iNewItemCnt
		
		'set the class status
		bSaved = True
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Saved Group file with " & iItemCnt & " messages (" & c_iNewItemCount & " New) for group " & c_sUserGroup
	End Sub
	
	Public Function ReadMessages(sUserGroup)
		'********************************************************************************
		' Purpose : Read Board FTPD Message store
		' Input   : String : sDestUser	: the Destination sUserGroup
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenStoreFile:ReadMessages"

		'load the message file
		c_sUserGroup = sUserGroup
		If Loaded = False Then
			Load()
		End If
		ReadMessages = Items.Data
	End Function
	
	Public Function GetMessageOwner(sUserGroup, bIndex)
		'********************************************************************************
		' Purpose : Read Board FTPD Message store
		' Input   : String : sUserGroup	: the Destination sUserGroup
		' Input   : boolean : bIndex	: the message index
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenStoreFile:GetMessageOwner"
		Dim aMessage 
		
		GetMessageOwner = vbNullString
		
		'load the message file
		c_sUserGroup = sUserGroup
		If Loaded = False Then
			Load()
		End If
		
		aMessage = Items.GetItemByIndex(bIndex)
			
		If IsArray(aMessage) Then 
			GetMessageOwner = aMessage(2)
		End If 

	End Function
	
	Public Function GetLastMessage(sUserGroup)
		'********************************************************************************
		' Purpose : Read Last Board FTPD Message store
		' Input   : String : sUserGroup	: the Destination sUserGroup
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenStoreFile:GetLastMessage"
		Dim aMessage 
		
		GetLastMessage = Array("","","","")
		
		'load the message file
		c_sUserGroup = sUserGroup
		Load()
		
		aMessage = Items.GetItemByIndex(1)
			
		If IsArray(aMessage) Then 
			GetLastMessage = aMessage
		End If 

	End Function
	
	Public Function DeleteAllMessages(sUser)
		'********************************************************************************
		' Purpose : Purge FTPD Board store
		' Input   : sUser : target user
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenBoardFile:DeleteAll"
		Dim iIndex,item
		
		'init the vars
		bIsNew = False
		bSaved = true
		iIndex = 1
		
		
		If ((sUser = Null ) Or sUser = (vbNullString)) Then
			If (Items.clear) Then
				c_iItemCount 	= 0
				c_iNewItemCount = 0
				bSaved 			= False
			End If 
		Else
			For Each item In Items.data
				If (LCase(item(2)) = LCase(sUser)) Then
				
					If (item(0) = "1") Then 
						bIsNew = True
					Else 
						bIsNew = False
					End If
										
					If (Items.DeleteItemByIndex(iIndex)) Then
						c_iItemCount = c_iItemCount - 1
						If bIsNew = True Then
							c_iNewItemCount = c_iNewItemCount - 1
						End If
						bSaved = False
					Else 
						iIndex = iIndex +1
					End If
				Else
					iIndex = iIndex +1
				End if 
				
			Next
		End If 
		Save
		DeleteAllMessages = True
	End Function
	
	Public Function AddMessage(sUser,sDestGroup,sMessage)
		'********************************************************************************
		' Purpose : Add a new message for a user
		' Input   :	String : sUser		: the Source user of the message
		'			String : sDestGgroup: the Destination GROUP
		'			String : sMessage	: the message
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenboardStoreFile:SendMessage"
		
		'init vars
		tTime 	= Empty
		sTime	= Empty
		
		'load the user message file
		UserGroup = sDestGroup
		load	
		
		tTime = Now()
		sTime = FormatDateTime(Now(),2) & " " & FormatDateTime(Now(),4)
		
		On Error Resume Next
		
		tTime = Now()
		sTime = FormatDateTime(Now(),2) & " " & FormatDateTime(Now(),4)
		sElement = Array("1",sTime,sUser,sMessage)
		
		If (Items.AddItem(sElement)) Then
			c_iItemCount    = c_iItemCount + 1
			c_iNewItemCount = c_iNewItemCount + 1
			bSaved          = False
		End If 
		
		Save
	End Function
	
	Public Function DeleteMessage(iIndex)
		'********************************************************************************
		' Purpose : Delete a message from a Board 
		' Input   :	Integer : iIndex	: the message index
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenBoardStoreFile:DeleteMessage"
		Dim index
		
		'init vars
		bIsNew 			= false
		sMessage 		= vbnullString
		DeleteMessage 	= False
		
		sMessage = Items.GetItemByIndex(iIndex)
		If (IsArray(sMessage)) Then
			If (sMessage(0) = "1") Then 
				bIsNew = True
			Else 
				bIsNew = False
			End If
					
			If (Items.DeleteItemByIndex(iIndex)) Then
				c_iItemCount = c_iItemCount - 1
				If bIsNew = True Then
					c_iNewItemCount = c_iNewItemCount - 1
				End If
				bSaved = False
			End If 
			Save
			DeleteMessage = True
		End If 
	End Function
	
	Public Sub ResetNewMessages(sUserGroup)
		'********************************************************************************
		' Purpose : Create an FTPD Message store as an object oOut
		' Input   : String : sDestUser : the Destination user
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenMsgStoreFile:ResetNewMessages"
		
		'Init the local vars
		Set aMessage = Nothing
		iItemCnt 	= 0
		iNewItemCnt 	= 0
		
		'On Error Resume Next
		
		c_sUserGroup = sUserGroup
		If Loaded = False Then
			Load()
		End If
		
		If NewItemCount > 0 Then
			'Reset the status
			For Each aMessage In Items.Data
				'check the New Message status
				If (aMessage(0) = "1") Then
					Items.UpdateItem iItemCnt+1,Array("0",aMessage(1),aMessage(2),aMessage(3))
					iNewItemCnt = iNewItemCnt + 1
					c_iNewItemCount 	= c_iNewItemCount - iNewItemCnt
					bSaved = False
				End If	
				iItemCnt = iItemCnt + 1
			Next
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] " & iNewItemCnt & " New messages were reset for Group " & sUserGroup
		Else 
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] 0 New messages to reset for Group " & sUserGroup
		End If 
		'Now save the data back to message store file
		If bSaved = False Then
			Save
		End If
	End Sub		
End Class


'######################################################################################
' Class Wrapper for RaidenFTPD Command Output File
'######################################################################################
Class RaidenOutFileClass
	
	'local vars
	Private sUserFile
	Private	oFile,oFso,oOut
	Private	sStr, sLine, sTmpStr  	
	Private ilength,iStrLength,ilenth1,ilenth2
	Private aMultiLineMsg
	
	'class vars
	Private c_sServer, c_sDestUser, c_iWidth, c_bSceneView, c_bOutputResult, c_sFilePath, c_sGCID, c_sCmdType
	
	'#---------------------------------------------------------------------------#
	Private Sub Class_Initialize
		c_bOutputResult	= True
		c_bSceneView	= True
		c_sFilePath 	= vbNullString
		c_sGCID 		= vbNullString
		c_sServer 		= vbNullString
		c_sDestUser		= vbNullString
		c_sCmdType		= "SiteCommand"
		c_iWidth		= 71
		Set oFile		= Nothing
		Set oOut		= Nothing
		Set oFso		= CreateObject("Scripting.FileSystemObject")
	End Sub
	
	Private Sub Class_Terminate
		Set oFso	= Nothing
		Set oFile	= Nothing
		Set oOut	= Nothing
	End Sub
	
	Public Property Get Path()
	Path = c_sFilePath
	End Property
	
	Public Property Let Path(sPath)
	If sPath <> vbNullString Then
		c_sFilePath = sPath
	End If 
	End Property
	
	Public Property Get Width()
	Width = c_iWidth
	End Property
	
	Public Property Let Width(iWidth)
	c_iWidth = iWidth
	End Property
	
	Public Property Get SceneView()
	SceneView = c_bSceneView
	End Property
	
	Public Property Let SceneView(bSceneView)
	c_bSceneView = bSceneView
	End Property
	
	Public Property Get Result()
	Result = c_bOutputResult
	End Property
	
	Public Property Get UserFile()
	UserFile = sUserFile
	End Property
	
	Public Property Let Result(bOutputResult)
	If TypeName(bOutputResult) = vbBoolean Then
		c_bOutputResult = bOutputResult
	End If 
	End Property
	
	Public Property Get GCID()
	GCID = c_sGCID
	End Property
	
	Public Property Let GCID(sGCID)
	If sGCID <> vbNullString Then
		c_sGCID = sGCID
	End If 
	End Property
	
	Public Property Get Server()
	Server = c_sServer
	End Property
	
	Public Property Let Server(sServer)
	If (VarType(sServer) = vbString) Then
		c_sServer = sServer
	End If 
	End Property
	
	Public Property Get DestUser()
	DestUser = c_sDestUser
	End Property
	
	Public Property Let DestUser(sDestUser)
	If (VarType(sDestUser) = vbString) Then
		c_sDestUser = sDestUser
	End If 
	End Property
	
	Public Property Get CmdType()
	CmdType = c_sCmdType
	End Property
	
	Public Property Let CmdType(sCmdType)
	If sCmdType <> vbNullString Then
		c_sCmdType = sCmdType
		Set oOut = Nothing
	End If 
	End Property	
	'#---------------------------------------------------------------------------#
	
	Public Sub Initialize()
		'********************************************************************************
		' Purpose : Create an FTPD reply (Output file) as an object oOut
		' Input   : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenOutFile:Initialize"
		
		'On Error Resume Next
		Err.clear
		
		If (LCase(CmdType) = "userlogin" Or  LCase(CmdType) = "sitecommand") Then
			sUserFile = c_sFilePath & "\OutPut" & "\ask-on" & c_sCmdType & "." & c_sGCID
		Else 
			If LCase(CmdType) = "notify" Then
				sUserFile = Path & "\Message" & "\site-Message-" & Server & "-" & DestUser & ".msg"
			End If
		End If 
		
		Set oOut = oFso.CreateTextFile(sUserFile, True)
		
		If Err.number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to create output: " & UserFile & ". The error was : " & Err.description & " (" & Err.number & ")"
			CmdProcessor.TerminateInSysErr
		Else
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] File: " & UserFile & " was successfully created."
		End If
		
	End Sub	
	
	Sub WriteResultOnly()
		'********************************************************************************
		' Puropose : Write the common intro of every user reply
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenOutFile:WriteResultOnly"
		
		If Helper.IsNothing(oOut) Then 
			Initialize
		End If 
		
		If (c_bOutputResult = True) Then 
			oOut.WriteLine "1"
		Else 
			oOut.WriteLine "0"
		End If
		
		Close
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Write Result : " & c_bOutputResult
	End Sub
	
	
	Sub WriteMsgHeader()
		'********************************************************************************
		' Puropose : Write the common intro of every user reply
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenOutFile:WriteMsgHeader"
		
		If Helper.IsNothing(oOut) Then 
			Initialize
		End If 
		
		If (c_bOutputResult = True) Then 
			oOut.WriteLine "1"
		Else 
			oOut.WriteLine "0"
		End If
		
		If c_bSceneView Then
			sStr = SCENEHEADER
		Else
			sStr = NORMALHEADER
		End If
		If (sStr <> vbNullString) Then
			oOut.WriteLine sStr
		End If
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Write Message Header."
	End Sub
	
	Sub WriteMsgHeaderNoResult()
		'********************************************************************************
		' Puropose : Write the common intro of every user reply
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenOutFile:WriteMsgHeaderNoResult"
		
		If Helper.IsNothing(oOut) Then 
			Initialize
		End If 
		
		If c_bSceneView Then
			sStr = SCENEHEADER
		Else
			sStr = NORMALHEADER
		End If
		If (sStr <> vbNullString) Then
			oOut.WriteLine sStr
		End If
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Write Message Header No Result."
	End Sub
	
	Sub WriteMsgSeperator()
		'********************************************************************************
		' Purpose : Build up a Formated Seperator string
		' Input   : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenOutFile:WriteMsgSeperator"
		
		If Helper.IsNothing(oOut) Then 
			Initialize
		End If 	
		
		If c_bSceneView Then
			sStr = SCENESEPARATOR
		Else
			sStr = NORMALSEPARATOR
		End If
		If (sStr <> vbNullString) Then
			oOut.WriteLine sStr
		End If
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Write Message Seperator"
	End Sub
	
	Sub WriteMsgTail()
		'********************************************************************************
		' Puropose : Write the common last lines of every user reply
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenOutFile:WriteMsgTail"
		
		If Helper.IsNothing(oOut) Then 
			Initialize
		End If 
		
		If c_bSceneView Then
			sStr = SCENETAIL
		Else
			sStr = NORMALTAIL
		End If
		If (sStr <> vbNullString) Then
			oOut.Write sStr
		End If
		Close
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Write Message Tail"
	End Sub
	
	Sub Close()
		'********************************************************************************
		' Puropose : Write the common last lines of every user reply
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenOutFile:Close"
		
		oOut.Close
		
		If Err.number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to close output: " & UserFile & ". The error was : " & Err.description & " (" & Err.number & ")"
			CmdProcessor.TerminateInSysErr
		Else
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] File: " & UserFile & " was successfully Closed."
		End If
		
		Set oOut = Nothing
	End Sub
	
	Sub WriteMsg (byVal sMessage, iPreSpace)
		'********************************************************************************
		' Purpose : Build and Write a Formated string
		' Input   : string  : sMessage	    : the input string
		'			integer : preSpace	: the desired pre spaces to insert
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenOutFile:WriteMsg"
		
		If Helper.IsNothing(oOut) Then 
			Initialize
		End If 
		
		If c_bSceneView Then
			aMultiLineMsg = Helper.BreakString(sMessage,vbNullString,c_iWidth - iPreSpace - 3,True)
			For Each sLine In aMultiLineMsg
				sTmpStr = "|" & Space(iPreSpace) & sLine
				sTmpStr = Helper.BuildString(sTmpStr,(c_iWidth-1)) & "|"
				oOut.WriteLine sTmpStr
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Write Message : " & sTmpStr
			Next
		Else
			aMultiLineMsg = Helper.BreakString(sMessage,vbNullString,c_iWidth - iPreSpace + 1,False)
			For Each sLine In aMultiLineMsg
				sTmpStr = Space(iPreSpace) & sLine
				oOut.WriteLine sTmpStr
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Write Message : " & sTmpStr
			Next
		End If
	End Sub
	
	Sub WriteMsgWithAppend (sMessage, sMessage2, iPreSpace)
		'********************************************************************************
		' Purpose : Build and write a Formated string
		' Input   : string  : sMessage	    : the input string
		'			string  : sMessage2		: the string to append
		'			integer : iPreSpace	: the desired pre spaces to insert
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenOutFile:WriteMsgWithAppend"
		
		If Helper.IsNothing(oOut) Then 
			Initialize
		End If 
		
		If c_bSceneView Then
			aMultiLineMsg = Helper.BreakString(sMessage,sMessage2,c_iWidth - iPreSpace - 3,True)
			For Each sLine In aMultiLineMsg
				sTmpStr = "|" & Space(iPreSpace) & sLine
				sTmpStr = Helper.BuildString(sTmpStr,(c_iWidth-1)) & "|"
				oOut.WriteLine sTmpStr
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Write Message : " & sTmpStr
			Next
		Else
			aMultiLineMsg = Helper.BreakString(sMessage,sMessage2,c_iWidth - iPreSpace + 1,False)
			For Each sLine In aMultiLineMsg
				sTmpStr = Space(iPreSpace) & sLine
				oOut.WriteLine sTmpStr
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Write Message : " & sTmpStr
			Next
		End If
	End Sub
End Class

'######################################################################################
' Class Wrapper for Array Management
'######################################################################################
Class ArrayWrapper
	
	'Class vars
	Private  c_aArray(), c_iClassItems, c_sClassType, c_sClassName, c_oParent
	'Local vars
	Private bFound, iCnt, iSize, iGetSize, iLoopValue, sValue, element, aNewArray
	
	'#---------------------------------------------------------------------------#
	Private Sub Class_Initialize()
		c_sClassName	= "ArrayWrapper"
		c_iClassItems 	= 0
		c_sClassType  	= vbNullString
		Set c_oParent	= Nothing
	End Sub
	
	Private Sub Class_Terminate()
		'Nothing
	End Sub
	'#---------------------------------------------------------------------------#
	'Class Properties
	Public Property Get Size()
	If IsArray(c_aArray) Then
		Size = c_iClassItems
	End If
	End Property
	
	Public Property Get oType()
	If IsArray(c_aArray) Then
		oType = c_sClassType
	End If
	End Property
	
	Public Property Let oType(strType)
	c_sClassType = strType
	End Property
	
	Public Property Get Data()
	Data = c_aArray
	End Property
	
	Public Property Get Parent()
	Set Parent = c_oParent
	End Property
	
	Public Property Let Parent(oParent)
	Set c_oParent = oParent
	End Property
	'#---------------------------------------------------------------------------#
	
	Public Function GetIndexByValue(sStringToTest)
		'**********************************************************************************
		' Purpose : This function loops the array and returns the index depending on weither
		'           or not a string exists as one of the values within the array. 
		' Inputs	: string	: sStringToTest	: string	: the string to check
		' Return	: integer	: the index in the array if found / -1 If Not found
		'****************************************************************************
		
		'Init vars
		iLoopValue 	= 0
		GetIndexByValue 	= -1
		
		If c_iClassItems > 0 Then
			For Each element In c_aArray
				If IsArray(element) Then
					sValue = element(0)
				Else
					sValue = element
				End If
				
				'cast to string
				sValue = sValue & vbNullString
				sStringToTest = sStringToTest & vbNullString
				
				If LCase(sStringToTest) = LCase(sValue) Then
					GetIndexByValue = iLoopValue + 1
					Exit Function
				End If
				iLoopValue = iLoopValue + 1
			Next
		End If
	End Function
	
	Public Function AddItem(sElement)
		'**********************************************************************************
		' Purpose : This function will Add the specified element to the array
		' Inputs	: string	: sElement	: the string element to add
		' Return	: integer	: OK = True / Error = false
		'**********************************************************************************
		
		On Error Resume Next
		
		'Detect the not initialized array
		If c_iClassItems = 0 Then
			ReDim c_aArray(0)
			c_aArray(0) = sElement
		Else
			ReDim Preserve c_aArray(c_iClassItems)
			c_aArray(c_iClassItems) = sElement
		End If
		
		c_iClassItems = c_iClassItems + 1
		
		If Err.Number <> 0 Then
			WScript.echo Err.Number & " : " & Err.Description
			AddItem = False
		Else 
			AddItem = True
		End If
		
		'Fire an event
		If (TypeName(FIRE_CLASS_EVENTS) <> "Nothing") Then
			If (FIRE_CLASS_EVENTS = True) Then
				Class_FireEvent "ArrayWrapper:" & c_sClassType, "AddItem", AddItem, sElement
			End If
		End If 
	End Function
	
	Public Function Clear()
		'**********************************************************************************
		' Purpose : This function will Reset the array
		' Inputs	: none
		'**********************************************************************************
		Erase c_aArray 
		c_iClassItems = 0
		
		'Detect Error
		If Err.Number <> 0 Then
			WScript.echo Err.Number & " : " & Err.Description
			Clear = False
		Else 
			Clear = True
		End If
		'clear the error state
		Err.Clear
		
		'Fire an event
		If (TypeName(FIRE_CLASS_EVENTS) <> "Nothing") Then
			If (FIRE_CLASS_EVENTS = True) Then
				Class_FireEvent "ArrayWrapper:" & c_sClassType, "Clear", Clear, vbNullString
			End If
		End If 
	End Function
	
	Public Function UpdateItem(index,sElement)
		'**********************************************************************************
		' Purpose 	: This function will Update the specified element to the array
		' Inputs	: integer 	: index 	: the index to edit
		'			  string	: sElement	: the string element to add
		' Return	: integer	: OK = True / Error = false
		'**********************************************************************************
		
		'init vars
		UpdateItem = False
		
		'Detect the not initialized array
		If c_iClassItems = 0 Then
			UpdateItem = False
		ElseIf ((index <= (c_iClassItems)) And (index > 0)) Then
			c_aArray(index-1) = sElement
			UpdateItem = True
		End If
		
		'Fire an event
		If (TypeName(FIRE_CLASS_EVENTS) <> "Nothing") Then
			If (FIRE_CLASS_EVENTS = True) Then
				Class_FireEvent "ArrayWrapper:" & c_sClassType,"UpdateItem", UpdateItem, index & ":" & Join(sElement,"|")
			End If
		End If 
	End Function
	
	Public Function DeleteItemByIndex(iElementIndex)
		'**********************************************************************************
		' Purpose 	: This function will delete the specified element from the array
		' Inputs	: integer	: iElementIndex	: the index of the element to delete
		'**********************************************************************************
		
		'init vars
		aNewArray 			= Empty
		sValue				= Empty
		bFound 				= False
		DeleteItemByIndex 	= False
		iLoopValue 			= 1
		
		iSize = GetSize(c_aArray)
		
		If ((iElementIndex <= (iSize)) And (iElementIndex > 0))Then 
			'extract the array data
			For Each element In c_aArray
				If iLoopValue <> iElementIndex Then
					iSize = GetSize(aNewArray)
					If iSize = 0 Then
						ReDim aNewArray(0) : aNewArray(0) = element 
					Else
						ReDim Preserve aNewArray(iSize) : aNewArray(iSize) = element
					End If
				Else 
					bFound = True
				End If
				iLoopValue = iLoopValue + 1
			Next
			
			'write the data
			If (bFound = True) Then
				iSize = GetSize(aNewArray)
				If (iSize >= 1) Then
					'Set the new values
					ReDim c_aArray(iSize-1)
					
					iLoopValue  = 0
					For Each element In aNewArray
						c_aArray(iLoopValue) = element
						iLoopValue = iLoopValue + 1
					Next
					c_iClassItems = iSize
				Else
					Erase c_aArray
					c_iClassItems = 0
				End If
				DeleteItemByIndex = True
			End If
		End If 
		
		If Err.Number <> 0 Then
			WScript.echo Err.Number & " : " & Err.Description
		End If 
		
		'clear the error state
		Err.Clear
		
		If (TypeName(FIRE_CLASS_EVENTS) <> "Nothing") Then
			If (FIRE_CLASS_EVENTS = True) Then
				Class_FireEvent "ArrayWrapper:" & c_sClassType,"DeleteIndex", DeleteItemByIndex, iElementIndex
			End If
		End If 
	End Function
	
	Public Function DeleteItemByValue(Value)
		'**********************************************************************************
		' Purpose : This function will delete the specified element from the array
		' Inputs	: string	: sElement	: the string Item to delete
		' Return	: integer	: OK = True / Error = false
		'**********************************************************************************
		
		'set the default output
		aNewArray 			= Empty
		sValue				= Empty
		bFound 				= False
		DeleteItemByValue 	= False
		iLoopValue 			= 0
		
		'Find the element
		For Each element In c_aArray
			If IsArray(element) Then
				sValue = element(0)
			Else
				sValue = element
			End If	
			
			'cast to string
			sValue 	= sValue & vbNullString
			Value 	= Value & vbNullString	
			
			If LCase(sValue) <> LCase(Value) Then
				iSize = GetSize(aNewArray)
				If iSize = 0 Then
					ReDim aNewArray(0) : aNewArray(0) = element 
				Else
					ReDim Preserve aNewArray(iSize) : aNewArray(iSize) = element
				End If
			Else 
				bfound = True
			End If
		Next
		
		' write the data
		If (bfound = True) Then
			iSize = GetSize(aNewArray)
			If (iSize >= 1) Then
				'Set the new values
				ReDim c_aArray(iSize-1)
				
				iLoopValue = 0
				For Each element In aNewArray
					c_aArray(iLoopValue) = element
					iLoopValue = iLoopValue + 1
				Next
				c_iClassItems = iSize
			Else
				Erase c_aArray
				c_iClassItems = 0
			End If 
			DeleteItemByValue = True
		End If 
		
		If Err.Number <> 0 Then
			WScript.echo Err.Number & " : " & Err.Description
			Err.Clear
		End If 
		
		If (TypeName(FIRE_CLASS_EVENTS) <> "Nothing") Then
			If (FIRE_CLASS_EVENTS = True) Then
				Class_FireEvent "ArrayWrapper:" & c_sClassType,"DeleteItem", DeleteItemByValue, Value
			End If 
		End If 
	End Function
	
	Public Function GetItemByIndex(iElementIndex)
		'**********************************************************************************
		' Purpose : This function will return the specified element from the array
		' Inputs	: integer	: iElementIndex	: the index of the element search for
		'**********************************************************************************
		'init vars
		GetItemByIndex = Empty
		
		If ((iElementIndex <= (c_iClassItems)) And (iElementIndex > 0)) Then
			GetItemByIndex = c_aArray(iElementIndex-1)
		End If
	End Function
	
	Public Function GetItemByValue(ElementValue)
		'**********************************************************************************
		' Purpose : This function will return the specified element from the array
		' Inputs	: integer	: ElementValue	: the value of the element to search for
		'**********************************************************************************
		GetItemByValue = Empty
		
		For Each element In c_aArray
			If IsArray(element) Then
				sValue = element(0)
			Else
				sValue = element
			End If	
			
			'cast to string
			sValue = sValue & vbNullString
			ElementValue = ElementValue & vbNullString	
			
			If (LCase(sValue) = LCase(ElementValue)) Then
				GetItemByValue = element
				Exit Function	
			End If
		Next
	End Function
	
	Private Function GetSize(aArray)
		'#--------------------------------------------------------------------------------#
		' Purpose : Check the array size
		'#--------------------------------------------------------------------------------#	
		On Error Resume Next
		iGetSize = UBound(aArray)
		
		If Err.Number Then
			If ((Err.Number = 9) Or(Err.Number = 13)) Then
				iGetSize = 0
			End If
		Else
			iGetSize = UBound(aArray) + 1
		End If
		On Error Goto 0
		GetSize = iGetSize
	End Function 
	
	Private Function Class_FireEvent (sSource, sEventType, bResult, aValues)
		'#--------------------------------------------------------------------------------#
		' Purpose : Fire an event
		'#--------------------------------------------------------------------------------#	
		If TypeName(c_oParent) <> "Nothing" Then 
			c_oParent.Class_Event sSource, sEventType, bResult, aValues
		End If 
	End Function
	
End Class

'######################################################################################
' Class Wrapper for Logging
'######################################################################################
Class UserLogClass
	
	Private bLoaded, bLogActive
	Private	sLogRoot,sLog
	Private oShell,oFso,oRegEx,oLog,oFldr,oFile
	Private iLogToKeep,iArr,iCnt,n,m,temp
	Private	aLog,aDate
	Private cFiles
	
	Private Sub Class_Initialize
		'#--------------------------------------------------------------------------------#
		' Purpose : Class Initialisation
		'#--------------------------------------------------------------------------------#	
		iLogToKeep	= NUMBEROFLOGS
		bLoaded		= False
		bLogActive	= False
		sLogRoot 	= SCRIPTPATH & "\Log"
		Set oShell 	= WScript.CreateObject("Wscript.Shell")
		Set oFso	= CreateObject("Scripting.FileSystemObject")
	End Sub
	
	Private Sub Class_Terminate
		'#--------------------------------------------------------------------------------#
		' Purpose : Class Terminate
		'#--------------------------------------------------------------------------------#	
		Dim currentSub : currentSub = "Class UserLog:Class_Terminate"
		
		'Clean up the logs
		DelLog
		
		Set oFso	= Nothing
		Set oShell	= Nothing
	End Sub
	
	Public Property Get LogPath()
	'#--------------------------------------------------------------------------------#
	' Purpose	: This function sets the file path
	'#--------------------------------------------------------------------------------#
	LogPath = sLogRoot
	End Property
	
	Public Property Let LogPath(sPath)
	'#--------------------------------------------------------------------------------#
	' Purpose	: This function sets the file path
	'#--------------------------------------------------------------------------------#
	If sPath <> vbNullString Then
		sLogRoot = sPath
	End If 
	End Property
	
	Public Property Get LogActive()
	'#--------------------------------------------------------------------------------#
	' Purpose	: This function sets the file path
	'#--------------------------------------------------------------------------------#
	LogActive = bLogActive
	End Property
	
	Public Property Get LogsToKeep()
	'#--------------------------------------------------------------------------------#
	' Purpose	: This function sets the file path
	'#--------------------------------------------------------------------------------#
	LogsToKeep = iLogToKeep
	End Property
	
	Public Property Let LogsToKeep(iValue)
	'#--------------------------------------------------------------------------------#
	' Purpose	: This function sets the file path
	'#--------------------------------------------------------------------------------#
	If (VarType(iValue) = vbInteger) Then
		iLogToKeep = iValue
	End If 
	End Property
	
	Public Property Get LogFile()
	'#--------------------------------------------------------------------------------#
	' Purpose	: This function sets the file path
	'#--------------------------------------------------------------------------------#
	LogFile = sLog
	End Property
	
	Public Function Start()
		'**********************************************************************************
		' Purpose : Initialize the Log interface, check log path
		'           Easily extend logging into other formats, Ex : Syslog, mail, xml etc.
		' Input   : none
		' Return  : bool	: True|False
		'**********************************************************************************
		Dim currentSub : currentSub = "Class UserLog:Initialize"
		
		If (Helper.CreateFolder(sLogRoot) <> True) Then
			LogEvent ERRORL, ABORT
			WScript.quit
		End If
		
		sLog = sLogRoot & "\" & Helper.GetDayTimeDate() & ".log"
		If (oFso.FileExists(sLog)) Then
			LogEvent INFORMATION, "[" & currentSub & "] The logfile: " & sLog & " allready exists. Appending random number to name of logfile"
			sLog = sLogRoot & "\" & Helper.GetDayTimeDate() & "_" & Helper.Random(9999) & ".log"
		End If
		
		LogEvent INFORMATION, "[" & currentSub & "] Logfile = " & sLog
		
		bLogActive = True
	End Function
	
	Public Sub LogEvent(eventType, sMessage)
		'**********************************************************************************
		' Purpose : Log interface, write various type of events to different formats, 
		'			NT Event, File etc.
		'           Easily extend logging into other formats, Ex : Syslog, mail, xml etc.
		' Input   : i : Event type, Integer 0 = None 1 = Success/Error 2 = Full
		'           sMessage : Log message, String
		'**********************************************************************************
		'Eventlog output
		If EVENTLOG = 1 Or EVENTLOG = 2 Then
			Set oRegEx = New RegExp
			'oRegEx.Pattern = "\[.*\] "
			'Changed to be able to print message file output when Message contains Brackets]
			oRegEx.Pattern = "^(\[[^*\]]*\])+"
			sMessage = oRegEx.Replace (sMessage, "")
			doEventLog eventType, Trim(sMessage)
			Set oRegEx = Nothing
		End If
		
		'Debug EventLog output
		If EVENTLOG = 3 Then
			doEventLog eventType, sMessage
		End If
		
		'Logfile output
		If FILELOG = 1 Or FILELOG = 2 Then
			Set oRegEx = New RegExp
			'oRegEx.Pattern = "\[.*\] "
			'Changed to be able to print message file output when Message contains Brackets]
			oRegEx.Pattern = "^(\[[^*\]]*\])+"
			sMessage = oRegEx.Replace (sMessage, "")
			doFileLog eventType, Trim(sMessage)
			Set oRegEx = Nothing
		End If
		
		'Debug logfile output
		If FILELOG = 3 Then
			doFileLog eventType, sMessage
		End If	
		
		'Debug screen output
		If FILELOG = 3 Or EVENTLOG = 3 Then
			WScript.echo sMessage
		End If
	End Sub
	
	Private Sub doFileLog(eventType, sMessage)
		'**********************************************************************************
		' Purpose : Write Event to logfile. Build an array of events until path logfile 
		'			is determined.
		'           If logfile can not be written. Events are redirected to eventlog.
		'           EventLog Level 0 = None 1 = Success/Error 2 = Full
		' Input   : eventType : Event type, Integer
		'           0 SUCCESS	1 ERROR (Const ERRORL)	2 WARNING	4 INFORMATION
		'           s : Log message, String
		' Use     : bLog Boolean True|False when actually start logging to file
		'**********************************************************************************
		On Error Resume Next
		
		Dim currentSub : currentSub = "Class UserLog:FileLog"
		
		'WScript.Echo eventType & " : " & sMessage
		'Make sure errorlevel 0
		Err.clear
		
		'Log to file if bLog flag is true
		If bLogActive = True Then
			
			Set oLog = oFso.OpenTextFile(sLog, FORAPPENDING, True)
			
			If Err.number <> 0 Then
				Helper.EchoErr Err, currentSub
				'Clear error
				Err.clear
				'Check if log folder exists, try to create
				If Helper.CreateFolder(Left(sLog, InStrRev(sLog, "\"))) Then
					Set oLog = oFso.OpenTextFile(sLog, FORAPPENDING, True)
					
				Else
					
					'Abort filelog operation if can't be written, switch to EventLog	
					EVENTLOG = 2
					FILELOG = 0
					Err.Raise = iErr
					LogEvent ERRORL, "[" & currentSub & "] Error occured while writing to logfile: " & sLog & ". The error was: " & Err.description
					LogEvent WARNING, "[" & currentSub & "] Events will permanently be redirected to eventlog. All events occured prior to this warning will now be written."
					
					'Write events from array to eventlog
					If IsArray(aLog) And aLog(0) <> vbNullString Then
						For iArr = 0 To UBound(aLog)
							LogEvent CInt(Left(aLog(iArr), 1)), Right(aLog(iArr), Len(aLog(iArr)) - 1)
						Next
						
						ReDim aLog(0)	
					End If
					
					Exit Sub
				End If
			End If
			
			'Write events from array to logfile
			If IsArray(aLog) And aLog(0) <> vbNullString Then
				For iArr = 0 To UBound(aLog)
					oLog.WriteLine Right(aLog(iArr), Len(aLog(iArr)) - 1)
				Next
				
				ReDim aLog(0)
			End If
			
			Select Case FILELOG
				Case 1
				Select Case eventType
					Case SUCCESS
					oLog.WriteLine Now & " SUCCESS " & sMessage
					Case ERRORL
					oLog.WriteLine Now & " ERROR   " & sMessage
					Case Else
					'Exit Sub 
				End Select
				Case 2
				Select Case eventType
					Case SUCCESS
					oLog.WriteLine Now & " SUCCESS     " & sMessage
					Case ERRORL
					oLog.WriteLine Now & " ERROR       " & sMessage
					Case WARNING
					oLog.WriteLine Now & " WARNING     " & sMessage
					Case INFORMATION
					oLog.WriteLine Now & " INFORMATION " & sMessage
					Case Else
					'Exit Sub
				End Select
				Case 3
				Select Case eventType
					Case SUCCESS
					oLog.WriteLine Now & " SUCCESS     " & sMessage
					Case ERRORL
					oLog.WriteLine Now & " ERROR       " & sMessage
					Case WARNING
					oLog.WriteLine Now & " WARNING     " & sMessage
					Case INFORMATION
					oLog.WriteLine Now & " INFORMATION " & sMessage
					Case Else
					'Exit Sub
				End Select
				Case Else
				Exit Sub
			End Select
			
			oLog.close
			'Set oLog = Nothing
		Else
			
			'Log to array while path to logfile determined
			If IsArray(aLog) Then
				iArr = UBound(aLog) + 1
				ReDim Preserve aLog(iArr)
			Else
				ReDim aLog(0)
				iArr = UBound(aLog)
			End If
			
			Select Case FILELOG
				Case 1
				Select Case eventType
					Case SUCCESS
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " SUCCESS " & sMessage
					Case ERRORL
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " ERROR   " & sMessage
					Case Else
					ReDim Preserve aLog(iArr-1)
					Exit Sub
				End Select
				Case 2
				Select Case eventType
					Case SUCCESS
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " SUCCESS     " & sMessage
					Case ERRORL
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " ERROR       " & sMessage
					Case WARNING
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " WARNING     " & sMessage
					Case INFORMATION
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " INFORMATION " & sMessage
					Case Else
					Exit Sub
				End Select
				Case 3
				Select Case eventType
					Case SUCCESS
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " SUCCESS     " & sMessage
					Case ERRORL
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " ERROR       " & sMessage
					Case WARNING
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " WARNING     " & sMessage
					Case INFORMATION
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " INFORMATION " & sMessage
					Case Else
					Exit Sub
				End Select
				Case Else
				Exit Sub
			End Select
		End If
	End Sub
	
	Private Sub doEventLog(eventType, sMessage)
		'********************************************************************************
		' Purpose : Write Event to Eventlog.
		'           EventLog Level 0 = None 1 = Success/Error 2 = Full
		' Input   : eventType : Event type, Integer
		'           0 SUCCESS 1 ERROR (Const ERRORL) 2 WARNING 4 INFORMATION
		'           sMessage : Log message, String
		'********************************************************************************
		Select Case EVENTLOG
			Case 1
			Select Case eventType
				Case SUCCESS
				oShell.LogEvent eventType, sMessage
				Case ERRORL
				oShell.LogEvent eventType, sMessage
				Case Else
				Exit Sub
			End Select
			Case 2
			Select Case eventType
				Case SUCCESS
				oShell.LogEvent eventType, sMessage
				Case ERRORL
				oShell.LogEvent eventType, sMessage
				Case WARNING
				oShell.LogEvent eventType, sMessage
				Case INFORMATION
				oShell.LogEvent eventType, sMessage
				Case Else
				Exit Sub
			End Select
			Case 3
			Select Case i
				Case SUCCESS
				oShell.LogEvent eventType, sMessage
				Case ERRORL
				oShell.LogEvent eventType, sMessage
				Case WARNING
				oShell.LogEvent eventType, sMessage
				Case INFORMATION
				oShell.LogEvent eventType, sMessage
				Case Else
				Exit Sub
			End Select
			Case Else
			Exit Sub
		End Select
	End Sub
	
	Private Sub DelLog()
		'**********************************************************************************
		' Purpose : Delete obsolete logs
		' Input   : None
		'**********************************************************************************
		Dim currentSub : currentSub = "Class UserLog:DelLog"
		Dim sProcessTime,tEndTime
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] Log CleanUP Started"
		
		If iLogToKeep <> 0 Then
			LogEvent INFORMATION, "[" & currentSub & "] Call KeepOnlyFiles " & sLogRoot & " " & iLogToKeep
			KeepOnlyFiles sLogRoot, iLogToKeep
		End If
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] Log CleanUP Complete"
		
		tEndTime = Timer()
		sProcessTime = ((tEndTime - tStartTime)*1000)
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] " & APPNAME & " " & APPVERMAJOR &  "." & APPVERMINOR & " ended successfully in " & sProcessTime & " milliseconds"
		
	End Sub
	
	Private Sub KeepOnlyFiles(sPath, iCount)
		'**********************************************************************************
		' Purpose : Delete obsolete files based upon date.
		'           n newest files are kept.
		' Input   : String (s) Path to root of files
		'           Integer : iCount : Number of folders to keep
		'**********************************************************************************
		On Error Resume Next
		
		Dim cFiles
		Dim currentSub : currentSub = "Class UserLog:KeepOnlyFiles"
		
		Set oFldr = oFso.GetFolder(sPath)
		Helper.EchoErr Err, currentSub
		
		If Err.number <> 0 Then
			LogEvent ERRORL, "[" & currentSub & "] An Error occured connecting to: " & sPath & " old files must be deleted manually."
			Exit Sub
		Else
			LogEvent INFORMATION, "[" & currentSub & "] Connected to: " & sPath
		End If
		
		Set cFiles = oFldr.Files
		Helper.EchoErr Err, currentSub
		
		If Err.number <> 0 Then
			LogEvent ERRORL, "[" & currentSub & "] An Error occured while listing files in folder: " & sPath & ". Old files must be deleted manually."
			Exit Sub
		Else
			LogEvent INFORMATION, "[" & currentSub & "] Succsessfully listed files in folder: " & sPath
		End If
		
		'Check if number of files greater than i
		If cFiles.Count <= iCount Then
			LogEvent INFORMATION, "[" & currentSub & "] Number of file(s) in root is: " & cFiles.Count & ". Number is less or equal to: " & iCount & " wich is the number of file(s) to keep."
			Exit Sub
		End If
		
		LogEvent INFORMATION, "[" & currentSub & "] Number of files in root is: " & cFiles.Count & ". Number is greater: " & iCount & " wich is the number of file(s) to keep."
		
		'ReDim array to number of folders
		ReDim aDate(cFiles.Count -1)
		
		LogEvent INFORMATION, "[" & currentSub & "] Creating array with fixed size: " & cFiles.Count -1 & ". Adding date of folders to array"
		
		iCnt = 0
		
		'Add date creation of all folders to array
		For Each oFile In cFiles
			LogEvent INFORMATION, "[" & currentSub & "] aDate(" & iCnt & ") = " & oFile.DateCreated & " (Path: " & oFile.Path & ")"
			aDate(iCnt) = oFile.DateCreated
			iCnt = iCnt + 1
		Next
		
		'Sorting array by date, ascent sort order (The famous bubble sort)
		LogEvent INFORMATION, "[" & currentSub & "] Sorting dates in array, ascent sort order"
		For n = 0 To UBound(aDate) -1 
			For m = n+1 To UBound(aDate) 
				If aDate(m) < aDate(n) Then
					temp = aDate(m)
					aDate(m) = aDate(n)
					aDate(n) = temp
				End If
			Next
		Next
		
		'Just logging
		LogEvent INFORMATION, "[" & currentSub & "] Array sorted, result in ascent order: "
		For iCnt = 0 To UBound(aDate)
			LogEvent INFORMATION, "[" & currentSub & "] aDate(" & iCnt & ") = " & aDate(iCnt)
		Next
		
		'Cut array, keep (i) rows with date of folders wich is going to be deleted
		ReDim Preserve aDate(UBound(aDate) - iCount)
		LogEvent INFORMATION, "[" & currentSub & "] Array aDate cut, remaing rows are: "
		
		'Even more logging (those debuggers ;))
		For iCnt = 0 To UBound(aDate)
			LogEvent INFORMATION, "[" & currentSub & "] aDate(" & iCnt & ") = " & aDate(iCnt)
		Next
		
		LogEvent INFORMATION, "[" & currentSub & "] Start deleting file(s)..."
		
		For Each oFile In cFiles
			For iCnt = 0 To UBound(aDate)
				If oFile.DateCreated = aDate(iCnt) Then
					LogEvent INFORMATION, "[" & currentSub & "] aDate(" & iCnt & ") = " & aDate(iCnt) & " matches DateCreated on file: " & oFile.Path & " (Date=" & oFile.DateCreated & ")"
					Helper.DeleteFile oFile.Path
					Exit For
				End If
			Next
		Next
		
		Helper.EchoErr Err, currentSub
		
		If Err.Number = 0 Then
			LogEvent SUCCESS, "[" & currentSub & "] Deleted " & UBound(aDate)+1 & " obsolete log files" 
		End If
		
	End Sub
End Class

'######################################################################################
' Class Wrapper for RaidenFTPD Command Processor
'######################################################################################
Class CmdProcessorClass

	'local vars
	Private sGroupHelp, sGroupHelp2, sMessage, sUser, sNewMsg
	Public aUsers, aUserMessages ,aUserMessage
	Private iItemCnt,iNewItemCnt
	Private bNewFound

	Sub CommandDispatcher()
		'********************************************************************************
		' Puropose : Dispatch the command
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:CommandDispatcher"
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] Command Dispatcher Started"
		
		'Check Options
		VerifyOptions cmdSITECMD,"",cmdOPTIONS 
		
		'Simple verification that the FTPD process is initiating the command in a way we expect
		If LCase(cmdSITECMD) <> LCase(SITECMD) Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] FTPD or this installation has been tamper with. Expected : " & SITECMD & " , Found : " & cmdSITECMD
			TerminateInSysErr
		End If
		
		'Check if user has requested help
		If LCase(cmdCMD) = "help" Or LCase(cmdCMD) = "-h" Or LCase(cmdCMD) = "-help" Then
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] User has requested help, call TerminateInHlp()"
			TerminateInHlp
		End If
		
		'Check if user is loging in
		If LCase(cmdCMD) = "login" Then
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] User is logging in, call TerminateInLogin()"
			TerminateInLogin
		End If
		
		'Check if user has Requested Board list
		If LCase(cmdCMD) = "list" Or LCase(cmdCMD) = "-list" Then
			If (((BOARD_LIST_OPS_ONLY = True) And (cmdLevel = 1)) Or (BOARD_LIST_OPS_ONLY = False)) Then
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] User requested : BOARD List, call TerminateInBoardList()"
				
				If (oArgs.Count < 8) Then
					TerminateInBoardList vbNullString
				Else
					If ( LCase(oArgs(7)) = "details") Then
						If (((BOARD_DETAILS_OPS_ONLY = True) And (cmdLevel = 1)) Or (BOARD_DETAILS_OPS_ONLY = False)) Then
							TerminateInBoardList "details"
						Else
							TerminateInHlp
						End If
					Else
						TerminateInBoardList vbNullString
					End If
				End If
			Else
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] User requested : BOARD List, Ignored"
				TerminateInHlp
			End If  
		End If
		
		'Check if user has requested read
		If LCase(cmdCMD) = "read" Or LCase(cmdCMD) = "-read" Then
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] User requested : READ message, call TerminateInMsgRead()"
			TerminateInReadMessages
		End If
		
		'Check if user has requested delete
		If LCase(cmdCMD) = "delete" Or LCase(cmdCMD) = "-delete" Then
			If (((DELETE_OPS_ONLY = True) And (cmdLevel = 1)) Or (DELETE_OPS_ONLY = False)) Then
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] User requested : DELETE message, call ProcessMessageDelete()"
				ProcessMessageDelete
			Else
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] User requested : BOARD delete, Ignored"
				TerminateInHlp	
			End If 
		End If
		
		'Check if user has requested send
		If LCase(cmdCMD) = "add" Or LCase(cmdCMD) = "-add" Then
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] User requested : ADD message, call TerminateInSendMessage()"
			TerminateInAddMessage
		End If
		
		'If we get here it means that the command was not recognized
		UserLog.LogEvent ERRORL, "[" & currentSub & "] User requested : Unknown Command : [" & cmdCMD & "]. call TerminateInHlp()"
		TerminateInHlp
	End Sub
	
	Public Function VerifyOptions(sCommand, aItem, aOptions)
		'********************************************************************************
		' Purpose : Verify the provided options
		' Input   : string : sCommand    : Command fired 
		'			array  : aItem       : Array of 4 strings containing the processed item details (notused)
		'			array  : aOptions    : Array of Options provided by the user
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:VerifyOptions"
		Dim sModifier, tmpModifier
		
		If TypeName(aOptions) = "Empty" Then
			Exit function
		End If
		
		'On Error Resume Next
		For Each sModifier In aOptions
			Select Case LCase(Left(sModifier,3))
				Case "-b:"
					tmpModifier = Replace(sModifier,Left(sModifier,3),vbNullString)
					
					If (CmdLEVEL  = 1) Then
						if (tmpModifier <> vbnullstring) Then
							DEF_BOARD = RaidenUserFile.GetRealGroupName(tmpModifier) 
							UserLog.LogEvent INFORMATION, "[" & currentSub & "] User forced Board: " & DEF_BOARD
						Else
							UserLog.LogEvent INFORMATION, "[" & currentSub & "] User tried to force unknown BOARD: " & tmpModifier
						End If 
					
					Else
						If ((tmpModifier <> vbnullstring) And RaidenUserFile.CheckUserGroup(cmdUSER,tmpModifier))  Then
							DEF_BOARD = RaidenUserFile.GetRealGroupName(tmpModifier) 
							UserLog.LogEvent INFORMATION, "[" & currentSub & "] User forced Board: " & DEF_BOARD
						Else
							UserLog.LogEvent INFORMATION, "[" & currentSub & "] User tried to force unknown BOARD: " & tmpModifier
						End If 
					End If 
				Case "-l:"
					tmpModifier = Replace(sModifier,Left(sModifier,3),vbNullString)
					If (TypeName(CInt(tmpModifier))= "Integer")Then
						If CInt(tmpModifier) > MESSAGE_STORE_LIMIT Then
							DEF_MESSAGE_DISPLAY_LIMIT = MESSAGE_STORE_LIMIT
							UserLog.LogEvent INFORMATION, "[" & currentSub & "] User forced MESSAGE_DISPLAY_LIMIT: Was maxed to " & DEF_MESSAGE_DISPLAY_LIMIT
						Else
							DEF_MESSAGE_DISPLAY_LIMIT = CInt(tmpModifier)
							UserLog.LogEvent INFORMATION, "[" & currentSub & "] User forced MESSAGE_DISPLAY_LIMIT: " & DEF_MESSAGE_DISPLAY_LIMIT
						End if
					Else
						UserLog.LogEvent INFORMATION, "[" & currentSub & "] User tried to force unknown MESSAGE_DISPLAY_LIMIT: " & tmpModifier
					End If 
				Case Else
					UserLog.LogEvent ERRORL, "[" & currentSub & "] User requested unknown option ("& sModifier & "). The option was ignored"
			End Select
		Next 
	End Function	
	
	Sub TerminateInHlp()
		'********************************************************************************
		' Puropose : Terminate the script, write help output to user
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:TerminateInHlp"
		
		sGroupHelp 	= vbNullString 
		sGroupHelp2 = vbNullString
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] HELP Command Process Started"
		
		RaidenOutFile.WriteMsgHeader
		RaidenOutFile.WriteMsg "Syntax : site " & cmdSITECMD & " <command> <options>",1
		RaidenOutFile.WriteMsgSeperator
		RaidenOutFile.WriteMsg "Commands :",1
		
		If (((BOARD_LIST_OPS_ONLY = True) And (cmdLEVEL = 1)) Or (BOARD_LIST_OPS_ONLY = False)) Then
			If (((BOARD_DETAILS_OPS_ONLY = True) And (cmdLEVEL = 1)) Or (BOARD_DETAILS_OPS_ONLY = False)) Then
				RaidenOutFile.WriteMsg "list [<details>][<Modifiers>]   : List <boards>",3
			Else
				RaidenOutFile.WriteMsg "list [<Modifiers>]              : List <boards>",3
			End if
		End If
		
		If (((DELETE_OPS_ONLY = True) And (cmdLEVEL = 1)) Or (DELETE_OPS_ONLY = False)) Then
			RaidenOutFile.WriteMsg "delete <board> [<#Id>|<all>]    : Delete <#msg> on <board>",3
		End If
		
		RaidenOutFile.WriteMsg "read [<Modifiers>]              : Read messages",3
		RaidenOutFile.WriteMsg "add <board> <message>           : Add <message> to <board>",3
		
		RaidenOutFile.WriteMsg "help                            : Show this help",3
		RaidenOutFile.WriteMsgSeperator
		RaidenOutFile.WriteMsg "Modifiers :",1
		RaidenOutFile.WriteMsg "-l:[int]    : The Message limit",2
		RaidenOutFile.WriteMsgWithAppend " -b:[String] : The board name","defaults: -l:" & LCase(DEF_MESSAGE_DISPLAY_LIMIT) & " -b:" & DEF_BOARD,1

		RaidenOutFile.WriteMsgTail
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] HELP Command Process Completed"	
		
		'terminate
		UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
		WScript.Quit
	End Sub
	
	Sub TerminateInReadMessages()
		'********************************************************************************
		' Puropose : Process Read Command, Terminate the script, 
		'            write help output to user
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:TerminateInMsgRead"
		
		'init vars
		Dim iCnt 
		iItemCnt 		= 0
		iNewItemCnt 	= 0
		aUserMessages	= Empty
		bNewFound		= False
		Dim sGroup
		Dim aUserGroups
		Dim bFirst : bFirst = True
		Dim iDISPLAY_LIMIT : iDISPLAY_LIMIT = DEF_MESSAGE_DISPLAY_LIMIT
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] READ Command Process Started"
		
		'Post Header
		RaidenOutFile.CmdType 	= "siteCommand"
		RaidenOutFile.WriteMsgHeader
			
		'Check Admin Acess
		If cmdLEVEL = 1 Then
			aUserGroups =  RaidenUserFile.GetAllGroups
		Else
			aUserGroups = RaidenUserFile.GetUserGroups(cmdUSER)
		End If 

		'Sort the User groups
		BubbleSort aUserGroups
		
		For Each sGroup In aUserGroups
			
			'check board selection
			If (LCase(DEF_BOARD) <> "*" And (LCase(sGroup) = LCase(DEF_BOARD)) Or (LCase(DEF_BOARD) = "*") )then
				'set the board and read
				If (Helper.Validate(sGroup,Split(ALLOWED_BOARDS,"|")))Then 
				
					RaidenBoardStoreFile.UserGroup = sGroup
					RaidenBoardStoreFile.load
					aUserMessages   = RaidenBoardStoreFile.ReadMessages(sGroup)
					iItemCnt		= RaidenBoardStoreFile.ItemCount
					

					'adapt counter
					If (iItemCnt < DEF_MESSAGE_DISPLAY_LIMIT) Then
						iDISPLAY_LIMIT = iItemCnt
					Else
						iDISPLAY_LIMIT = DEF_MESSAGE_DISPLAY_LIMIT
					End If 
					
					If Not(bFirst) Then 
						RaidenOutFile.WriteMsgSeperator
					End If 
					
					'Read info
					Select Case iItemCnt
						Case 0
							RaidenOutFile.WriteMsg "Board [" & sGroup & "] : No Message.",1
						Case 1
							RaidenOutFile.WriteMsgWithAppend "Board [" & sGroup & "] : " & iItemCnt & " message.","Latest " & iDISPLAY_LIMIT & " Message",1
						Case Else
							RaidenOutFile.WriteMsgWithAppend "Board [" & sGroup & "] : " & iItemCnt & " messages.","Latest " & iDISPLAY_LIMIT & " Messages",1
					End Select
					
					RaidenOutFile.WriteMsg "",0
					' flag
					bFirst = False
					
					'Process messages
					If iItemCnt > 0 then

						'Post the Command Output
						iItemCnt = 1
						iNewItemCnt = 0
						Dim iEnd, iStart
	
						If MESSAGE_ACEND_ORDER Then
							iEnd = (UBound(aUserMessages) - DEF_MESSAGE_DISPLAY_LIMIT +1 )
							
							If iEnd < 0 Then
								iEnd = 0
							End If 
						
							For iCnt = UBound(aUserMessages) To iEnd Step -1 
									aUserMessage = aUserMessages(iCnt)
									If (aUserMessage(0) = "1") Then
										sNewMsg = "*"
										bNewFound = True
										iNewItemCnt = iNewItemCnt + 1
									Else 
										sNewMsg = " "
									End If	
									RaidenOutFile.WriteMsg sNewMsg & "#" & Helper.BuildString (iItemCnt,2) & " " & aUserMessage(2) & "@" & aUserMessage(1),1
									RaidenOutFile.WriteMsg  aUserMessage(3),6
									iItemCnt = iItemCnt + 1
							Next
						Else
							iStart = (UBound(aUserMessages) - MESSAGE_DISPLAY_LIMIT +1 )
							
							If iStart < 0 Then
								iStart = 0
							End If 
							
							For iCnt = iStart To UBound(aUserMessages) Step 1
							    aUserMessage = aUserMessages(iCnt)
								'check the New Message status
								If (aUserMessage(0) = "1") Then
									sNewMsg = "*"
									bNewFound = True
									iNewItemCnt = iNewItemCnt + 1
								Else 
									sNewMsg = " "
								End If	
									RaidenOutFile.WriteMsg sNewMsg & "#" & Helper.BuildString (iItemCnt,2) & " " & aUserMessage(2) & "@" & aUserMessage(1),1
									RaidenOutFile.WriteMsg  aUserMessage(3),6
								
								iItemCnt = iItemCnt + 1
							Next
						End If 
						
						'Reset the NewMessage flag
						RaidenBoardStoreFile.ResetNewMessages sGroup 
					End If
				End if 
			End If 
		next
		RaidenOutFile.WriteMsgTail

		UserLog.LogEvent SUCCESS, "[" & currentSub & "] READ Command Process Completed"
		
		'terminate
		UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
		WScript.Quit
	End Sub
	
	Sub TerminateInDeleteAllMessages()
		'********************************************************************************
		' Puropose : Purge the messages, Terminate the script, 
		'            write help output to user
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:TerminateInDeleteAllMessages"
		Dim sDestBoard, iMsgIndex, aMsgArray
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] DELETE ALL Command Process Started"
		
		'load the destination board
		sDestBoard = oArgs(7)
		
		'Validate User access to command and process
		ValidateUserAccess cmdUSER, sDestBoard, cmdLEVEL
		
		'Check and load the board file
			If RaidenBoardStoreFile.Loaded = False Then
				RaidenBoardStoreFile.DestUser = sDestBoard
				RaideBoardStoreFile.load		
			End If
			
			If ((DELETE_OWN_ONLY = True) And (cmdLevel = 0)) Then
				RaidenBoardStoreFile.DeleteAllMessages cmdUSER
				'Write the Command Output
				PostMessage RaidenOutFile, "Deleted all (" & cmdUSER & ") Messages in Board " & sDestBoard
 
			Else
				RaidenBoardStoreFile.DeleteAllMessages ""
				'Write the Command Output
				PostMessage RaidenOutFile, "Deleted all Messages in Board " & sDestBoard

			End If 
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] DELETE ALL Command Process Completed"
		
		'terminate
		UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
		WScript.Quit
	End Sub
	
	Sub TerminateInDeleteMessage(iIndex)
		'********************************************************************************
		' Puropose : Delete a message, write result output to user, Terminate the script
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:TerminateInDeleteMessage"
		Dim sDestBoard, aCurrentGroups, bGroupFound , sRealDestGroup, sGroup, sItemOwner, iRealIndex
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] DELETE Command Process Started"
		
		'load the destination board
		If oArgs.count <= 7 Then
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] Delete Command is missing parameters"
			TerminateInMsg currentSub, ERRORL,  "Delete Command is missing parameters"
		Else
		
			sDestBoard = oArgs(7)
			sRealDestGroup = RaidenUserFile.GetRealGroupName(sDestBoard)
								
			'Validate User access to command and process
			If (ValidateUserAccess(cmdUSER, sDestBoard, cmdLEVEL)) Then
				
				'get the real groupName
				
				
				'Check and load the Board file if required
				If RaidenBoardStoreFile.Loaded = False Then
					RaidenBoardStoreFile.UserGroup = sDestBoard
					RaidenBoardStoreFile.load		
				End If
				
				'get the correct index
				If MESSAGE_ACEND_ORDER Then
					iRealIndex = RaidenBoardStoreFile.ItemCount - iIndex + 1
				Else
					iRealIndex = iIndex
				End If 
				
				'Clear the data
				'If (DELETE_OWN_ONLY = True) Then
					If cmdLEVEL = 0 Then 
					
						If ((LCase(RaidenBoardStoreFile.GetMessageOwner(sRealDestGroup,iRealIndex)) = LCase(cmdUSER)) And (DELETE_OWN_ONLY = True)) Then
							'RaidenBoardStoreFile.DeleteMessage iRealIndex
						
							'Write the Command Output
							PostMessage RaidenOutFile, "Deleted Message #" & iIndex &" from Board " & sRealDestGroup
						Else
							PostMessage RaidenOutFile, "You can not delete the message #" & iIndex &" from Board " & sRealDestGroup
						End If 
					Else
						RaidenBoardStoreFile.DeleteMessage iRealIndex
						
						'Write the Command Output
						PostMessage RaidenOutFile, "Deleted Message #" & iIndex &" from Board " & sRealDestGroup
					End If
				'End If  
			End If 

		End If 				
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] DELETE Command Process Completed"
		
		'terminate
		UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
		WScript.Quit
	End Sub
	
	Function ValidateUserAccess(sUser, sGroup, bCmdLEVEL)
		'********************************************************************************
		' Puropose : ValidateUserAccess 
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:ValidateUserAccess"
		Dim sDestBoard, aCurrentGroups, bGroupFound , sRealDestGroup, sGroupItem, sItemOwner, iRealIndex, aItems, iMsgCnt, iCnt		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] VALIDATE ACCESS Command Process Started"
		
		'Default to ok
		ValidateUserAccess = True
				
			If ((DELETE_OPS_ONLY = True) And (bCmdLEVEL = 1)) Or (DELETE_OPS_ONLY = False) Then
				
				'load the destination board
				sDestBoard = sGroup
								
				'Filter the user list based on configuration
				If ((USER_LIST_OWN_BOARD_ONLY = True) And (bCmdLEVEL  = 0)) Then
					aCurrentGroups = RaidenUserFile.GetFilteredGroups(sUser,True)
				Else
					aCurrentGroups = RaidenUserFile.GetFilteredGroups(sUser,False)
				End If 
				
				'Now check if cmdUser has access to the Dest Board
				bGroupFound = False
				If (Helper.GetSize(aCurrentGroups) > 0) Then
					For Each sGroupItem In aCurrentGroups
						If LCase(sDestBoard) = LCase(sGroupItem) Then
							sDestBoard = sGroupItem
							bGroupFound = True
							Exit For
						End If
					Next
				End If 
				
				If (bGroupFound) Then
					UserLog.LogEvent INFORMATION, "[" & currentSub & "] Destination Board: " & sDestBoard & " is valid."
								
					If not(Helper.Validate(sDestBoard,Split(ALLOWED_BOARDS,"|")))Then 
						UserLog.LogEvent INFORMATION, "[" & currentSub & "] Destination Board: " & sDestBoard & " is NOT Enabled"
						TerminateInMsg currentSub, ERRORL,  "Board " & sDestBoard & " is not Enabled"
					Else
						UserLog.LogEvent INFORMATION, "[" & currentSub & "] Destination Board: " & sDestBoard & " is Enabled"
					End If 
				Else 
					UserLog.LogEvent INFORMATION, "[" & currentSub & "] Destination Board: " & sDestBoard & " is NOT valid"
					TerminateInMsg currentSub, ERRORL,  "Board " & sDestBoard & " is not valid"
				End If
		Else 
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] Deleted message requires Admin level"
			TerminateInMsg currentSub, ERRORL,  "Delete operation On Board requires admin access"	
		End If 
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] VALIDATE ACCESS Command Process Completed"
		
		'return success
		ValidateUserAccess = true
		UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
	End Function


	Sub TerminateInBoardList(slistOption) 
		'********************************************************************************
		' Puropose : List Groups, write output to user, Terminate the script
		' Input    : None
		'********************************************************************************
		Dim aGroups, aGroupUsers
		Dim sGroup, sUser, sMessage, sLastMessage
		Dim iUserCount
		
		Dim currentSub : currentSub = "Class CmdProcessorClass:TerminateInBoardListCommand"
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] Board LIST Process Started"
		
		'Filter the user list based on configuration
		If ((USER_LIST_OWN_BOARD_ONLY = True) And (cmdLevel = 0)) Then
			aGroups = RaidenUserFile.GetFilteredGroups(cmdUSER,True)
		Else
			aGroups = RaidenUserFile.GetFilteredGroups(cmdUSER,False)
		End If 
		
		BubbleSort aGroups
		
		RaidenOutFile.WriteMsgHeader
		RaidenOutFile.WriteMsgWithAppend "Board list","User ["& cmdUSER & "]",1
		RaidenOutFile.WriteMsgSeperator
		
		'build the Group list
		If (Helper.GetSize(aGroups) = 0) Then
			RaidenOutFile.WriteMsg "No Boards Found",4
		Else
			iCnt = 1
			For Each sGroup In aGroups
			
				'check board selection
				If (LCase(DEF_BOARD) <> "*" And (LCase(sGroup) = LCase(DEF_BOARD)) Or (LCase(DEF_BOARD) = "*") )then
					If (Helper.Validate(sGroup,Split(ALLOWED_BOARDS,"|")))Then 
						'read board last message
						sLastMessage = RaidenBoardStoreFile.GetLastMessage(sGroup)
						
						'get users
						aGroupUsers = RaidenUserFile.GetGroupUsers(sGroup)
						BubbleSort aGroupUsers
						iUserCount = Helper.GetSize(aGroupUsers)
						If (iUserCount >= 0) Then
							If (sLastMessage(0) <> vbnullstring) Then
								RaidenOutFile.WriteMsgWithAppend  "[#" & Helper.BuildString (iCnt,2) & "] [" & sGroup &"]: " & sLastMessage(2) & "@" & sLastMessage(1) , ": [" & iUserCount & " user(s)]" ,1
							Else
								RaidenOutFile.WriteMsgWithAppend  "[#" & Helper.BuildString (iCnt,2) & "] [" & sGroup &"]: " & "No Message" , ": [" & iUserCount & " user(s)]" ,1	
							End if 
												
							If (((BOARD_DETAILS_OPS_ONLY = True) And (cmdLevel = 1)) Or (BOARD_DETAILS_OPS_ONLY = False)) Then
								If (LCase(sListOption) =  "details") Then
									For Each sUser In aGroupUsers
										sMessage = sMessage & "[" & sUser & "] "
									Next 
									RaidenOutFile.WriteMsg  sMessage,7
									sMessage = vbNullString
								End If
							End If
							iCnt = iCnt +1
						End If 
					End if
				End if 
			Next
		End If 
		
		RaidenOutFile.WriteMsgTail
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] BOARD LIST Process Completed"	
		
		'terminate
		UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
		WScript.Quit
	End Sub
	
	
	Sub ProcessMessageDelete()
		'********************************************************************************
		' Puropose : Process the delete command Terminate the script,
		'            write output to user
		' Input    : None
		'********************************************************************************
		Dim iMsgCnt
		Dim Option1, Option2
		
		Dim currentSub : currentSub = "Class CmdProcessorClass:ProcessMessageDelete"
		
		If oArgs.count <= 8 Then
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] Delete Command is missing parameters"
			TerminateInHlp
		Else
			Option1 = oArgs(7)
					
			UserLog.LogEvent SUCCESS, "[" & currentSub & "] DELETE Command Process Started"
			
			'Filter the user list based on configuration
			If (ValidateUserAccess(cmdUSER, Option1, cmdLEVEL)) then
				'Check and load the Board file if required
				If ((RaidenBoardStoreFile.Loaded = False) Or (LCase(RaidenBoardStoreFile.UserGroup) <> LCase(Option1))) Then
					RaidenBoardStoreFile.UserGroup = Option1
					RaidenBoardStoreFile.load		
				End If
				
				iMsgCnt = RaidenBoardStoreFile.ItemCount
				
				If (iMsgCnt = 0) Then
					TerminateInMsg currentSub, ERRORL,  "No Messages to delete on board " & Option1
				Else
					'verify the command options
					If (oArgs.Count < 8) Then
						TerminateInMsg currentSub, ERRORL,  "Message delete missing parameter"
					Else
					    Option2 = oArgs(8)
						UserLog.LogEvent INFORMATION, "[" & currentSub & "] User has requested delete with option : " & Option1 & ";" & Option2
						If (LCase(Option2) = "all") Then
							TerminateInDeleteAllMessages()
						End If
						If (IsNumeric(Option2))Then
							If ((CInt(Option2) <= iMsgCnt) And (CInt(Option2) > 0)) Then
								TerminateInDeleteMessage CInt(Option2)
							End If
						End If
						'if we get here ther is some thing wrong with the command
						TerminateInMsg currentSub, ERRORL,  "Message delete wrong parameter"
					End If 			
				End If 
			End if
		End if
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] DELETE Command Process Completed"
	End Sub
	
	Sub TerminateInAddMessage()
		'********************************************************************************
		' Puropose : Process the Send command, Terminate the script, 
		'            write output to user
		' Input    : None
		'********************************************************************************
		Dim sDestBoard, sRealDestGroup, sMessage, sCurrentUserGroups, sCurrentGroups, iUserCnt, sGroup, grpUser
		Dim aCurrentGroups
		Dim bGroupFound
		
		Dim currentSub : currentSub = "Class CmdProcessorClass:TerminateInSendMessage"
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] SEND Command Process Started"
		'On Error Resume next
		
		'check if we have all the inputs
		If (oArgs.Count < 9) Then
			TerminateInMsg currentSub, ERRORL, "Add Message missing parameter(s)"
		End If 
		
		'load the destination board
		sDestBoard = oArgs(7)
		
		'get the real Board Name 
		Dim sRealBoardName 
		sRealBoardName = RaidenUserFile.GetRealGroupName(sDestBoard)
		If sRealBoardName <> vbNullString Then
			sDestBoard = sRealBoardName
		End If 
		
		'Filter the user list based on configuration
		If (ValidateUserAccess(cmdUSER, sDestBoard, cmdLEVEL)) then
		
			'load the message
			sMessage = oArgs(8)
			For iCnt = 9 To oArgs.Count -1
				sMessage = sMessage & " " & oArgs(iCnt)
			Next
			
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] Sending Message to Destination Board: " & sRealBoardName
			
			'Store the message
			RaidenBoardStoreFile.AddMessage cmdUSER, sDestBoard, sMessage
			
			'Write the Command Output 
			PostMessage RaidenOutFile, "Message successfully posted on board " & sRealBoardName
			
			'Notify the users (Requires TuS-Message.v2.11 or higher)
			If ADDON_ENABLE_NOTIFICATION = True Then
				If Helper.FileExists(RAIDENFTPD_PATH & ADDON_MESSAGE_PATH,False) Then
					
					For Each grpUser In RaidenUserFile.GetGroupUsers(sDestBoard)
						If LCase(cmdUSER) <> LCase(grpUser) Then
							Notify grpUser, cmdSERVER, " New message posted on Board " & sRealBoardName
							UserLog.LogEvent SUCCESS, "[" & currentSub & "] Notification Sent to user: " & grpUser
						End If 
					next
				Else
					UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to send Notification for user: " & cmdUSER
				End If
			End If
		End if
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] SEND Command Process Completed"
		
		'terminate
		UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
		WScript.Quit
	End Sub
	
	Sub TerminateInSysErr()
		'********************************************************************************
		' Puropose : Terminate the script
		'            Inform the user about the error.
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:TerminateInSysErr" 
		
		UserLog.LogEvent ERRORL, "[" & currentSub & "] " & ABORT
		
		PostMessage RaidenOutFile, "An internal system error has occured. The error has been logged, please report this error to system administrator."
		UserLog.LogEvent ERRORL, "[" & currentSub & "] Script Aborted"
		UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
		WScript.quit
	End Sub
	
	Sub TerminateInMsg(currentSub, ErrLevel ,sMessage)
		'********************************************************************************
		' Puropose : Terminate the script, write output message to user
		' Input    : string : sMessage : the message to post
		'********************************************************************************
		PostMessage RaidenOutFile, sMessage
		UserLog.LogEvent ErrLevel, "[" & currentSub & "] " & sMessage
		UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
		WScript.quit
	End Sub
	
	Sub PostMessage(oOutFile,sMessage)
		Dim currentSub : currentSub = "Class CmdProcessorClass:PostMessage"
		
		oOutFile.WriteMsgHeader
		oOutFile.WriteMsg sMessage,1
		oOutFile.WriteMsgTail
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] " & "Posted Message: " & sMessage
	End Sub
	
	Public Function Notify(sUser, sSERVER, sMessage)
		'********************************************************************************
		' Purpose : Notify the user
		' Input   : sUser	   : the user
		'           sMessage   : the Message
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:Notify"
		Dim sCmdRun, oFolder, Folder
	
		sCmdRun = "cscript.exe " & Chr(34) & RAIDENFTPD_PATH & ADDON_MESSAGE_PATH & Chr(34)
		sCmdRun = sCmdRun & " " & Chr(34) & "0000000" & Chr(34) & " " & 1 & " " & Chr(34) & sSERVER & Chr(34) & " " & Chr(34) & "Board" & Chr(34) & " message send " & sUSER & " " & sMessage
		Helper.ShellRun sCmdRun,0,False,""
	End Function
	
	Private Function BubbleSort(byRef list)
    'Its a sorting procedure for 1-dimensional arrays named List
    'The procedure takes each array element, if it is greater than the next element, the two elements swap positions.
    'The evaluation is repeated for every pair of items (that is n-1 times)
    'Change data type to As Integer if your array isnt text
     Dim First, Last
     Dim i, j 
     Dim temp 
	 First = LBound(list)
     Last = UBound(list)
	     For i = First To (Last-1)
	         For j = i + 1 To Last
	             If list(i) > list(j) Then
	                 temp = list(j)
	                 list(j) = list(i)
	                 list(i) = temp
	             End If
	         Next
	     Next
 	End Function
	
End Class

'######################################################################################
' Class Wrapper for Helper. Functions
'######################################################################################
Class HelperClass
	
	Private oShell,oExec,oFso,oFile,oStdOut,Element
	Private iSize,iInt,iCnt,iWordBreak,iCurrentLenth, intSeconds, intMilliseconds
	Private sScriptDir, sFilePath, sStreamData, sFolder, sUnc, sResult, sTempFile
	Public aResult
	Private bFound
	'#---------------------------------------------------------------------------#
	Private Sub Class_Initialize
		Set oFso		= CreateObject("Scripting.FileSystemObject")
		Set oShell		= CreateObject("Wscript.Shell")
	End Sub
	
	Private Sub Class_Terminate
		Set oFso		= Nothing
		Set oShell		= Nothing
	End Sub
	'#---------------------------------------------------------------------------#
	
	Function EchoErr(myError, sProcedure)
		'**********************************************************************************
		' Purpose : Verify and Post Err message
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helpers:EchoErr"
		
		If Err.Number <> 0 Then
			WScript.echo "[" & sProcedure & "] ERROR: Number:" & Err.Number & " : " & Err.Description
			UserLog.LogEvent ERRORL, "[" & sProcedure & "] ERROR: Number:" &Err.Number & " : " & Err.Description
		End If
	End Function
	
	Sub import (sFileName)
		sScriptDir = oFso.GetParentFolderName(WScript.ScriptFullName)   
		sFilePath = oFso.BuildPath(sScriptDir,sFileName)   
		Const ForReading = 1   
		
		Set oFile = oFso.OpenTextFile(sFilePath,ForReading)   
		sStreamData = oFile.ReadAll()   
		ExecuteGlobal sStreamData   
	End Sub
	
	Public Function Validate(sStringToTest,aArray)
		'#--------------------------------------------------------------------------------#
		' Purpose : Check if the element is part of an array
		'#--------------------------------------------------------------------------------#	
		bFound = False
		
		If (IsArray(aArray)) Then
			For Each Element In aArray				
				If LCase(sStringToTest) = LCase(Element) Then
					bFound = True
					Exit For
				End If
			Next 
		End If
		Validate = bFound
	End Function 
	
	Public Function GetSize(varArray)
		'#--------------------------------------------------------------------------------#
		' Purpose : Check the array size
		'#--------------------------------------------------------------------------------#	
		iSize = 0
		
		On Error Resume Next
		iSize = UBound(varArray)
		If Err.Number Then
			If Err.Number = 9 Then
				iSize = 0
			End If
		Else
			iSize = UBound(varArray) + 1
		End If
		GetSize = iSize
	End Function 
	
	Public Function  IsNothing (Obj)
		'#--------------------------------------------------------------------------------#
		' Purpose : Check if object is Nothing
		'#--------------------------------------------------------------------------------#	
		If TypeName(Obj) = "Nothing" Then
			IsNothing = True
		Else
			IsNothing = False
		End If
	End Function
	
	Function FileExists(sFilePath, bRequired)
		'**********************************************************************************
		' Purpose : Verify presense of a file, abort the script if the file is not present
		'		    and it's required.
		' Input   : string	: sFilePath 		: Path to file
		'           bool	: bRequired	: True|False
		' Return  : bool	: True|False
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper:FileExists"
		
		If (oFso.FileExists(sFilePath)) Then
			UserLog.LogEvent SUCCESS, "[" & currentSub & "] The file: " & sFilePath & " is present."
			FileExists = True
		Else
			UserLog.LogEvent ERRORL, "[" & currentSub & "] The file: " & sFilePath & " does not exist."
			FileExists = False
		End If
		
		If bRequired And FileExists = False Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] The file: " & sFilePath & " is required for futher processing of this script."
			CmdProcessor.TerminateInSysErr
		End If
	End Function
	
	Function CreateFolder(sPath)
		'**********************************************************************************
		' Purpose : Create a folder, or a subset of folders based upon one path. 
		'           Support both path and unc path. Ex : \\fqdn\share\my\path or 
		'           D:\share\my\path. If only \\fqdn\share or D:\Share exists, 
		'           function loop folder creation until path provided is created.
		' Input   : string	: sPath	: Path to folder
		' Return  : bool	: True if folder exists or successfully created
		'**********************************************************************************
		sFolder = vbnullString
		
		Dim currentSub : currentSub = "Class Helpers:CreateFolder"
		
		On Error Resume Next
		
		'Add missing \ if required
		If Right(sPath, 1) <> "\" Then
			sPath = sPath & "\"
		End If
		
		'Check if path is UNC replace base path \\server.fqdn\something with "\"
		If Left(sPath, 2) = "\\" Then
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] UNC Path: " & sPath
			sUNC = sPath
			Set oRegEx = New RegExp
			oRegEx.Pattern = "\\\\[A-Za-z0-9.]+\\\w+\$?\\"
			sResult = oRegEx.Replace (sPath, "")
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] UNC stripped, result: " & sResult
			sUnc = Left(sPath, Len(sPath) - Len(sResult))
			sFolder = sUnc
		End If
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Start creating directory structure: " & sPath
		
		'Check and create the folder tree
		Do Until sFolder = sPath
			sFolder = Left(sPath, InStr(Len(sFolder) + 1, sPath, "\"))
			'UserLog.LogEvent INFORMATION, "[" & currentSub & "] Checking if folder exists: " & sFolder
			If Not oFso.FolderExists(sFolder) Then
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Creating folder: " & sFolder
				ofso.CreateFolder(sFolder)
				If Err.number <> 0 Then
					UserLog.LogEvent ERRORL, "[" & currentSub & "] Error creating: " & sFolder & ". The error was: " & Err.description
					Exit Function
				End If
			End If
		Loop
		
		If Right(sPath, 1) = "\" Then
			sPath = Left(sPath, Len(sPath) -1)
		End If
		CreateFolder = True
	End Function
	
	Sub DeleteFile(sPath)
		'**********************************************************************************
		' Purpose : Delete file
		' Input   : String : sPath : path to file
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helpers:DeleteFile"
		
		On Error Resume Next
		Err.clear
		
		oFso.DeleteFile sPath, True
		
		If Err.number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to delete File: " & sPath & ". The error was: " & Err.description & " (" & Err.number & ")"
		Else
			UserLog.LogEvent SUCCESS, "[" & currentSub & "] File: " & sPath & " was successfully deleted."
		End If
	End Sub
	
	Function GetDayTimeDate()
		'**********************************************************************************
		' Purpose : Get Day,Date,Time
		' Input   : None
		' Return  : Current day of week + Date + Time
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helpers:GetDayTimeDate"
		
		GetDayTimeDate = WeekdayName(Weekday(Now, vbUseSystemDayOfWeek),,vbUseSystemDayOfWeek) & " " & Date & " "
		
		intSeconds = (Hour(Now) * 3600) + (Minute(Now) * 60) + Second(Now) 
        intMilliseconds = Timer() - intSeconds 
        intMilliseconds = Fix(intMilliseconds * 10000) 
		
		If CInt(Hour(Now)) < 10 Then
			GetDayTimeDate = GetDayTimeDate & "0" & Hour(Now) & "."
		Else
			GetDayTimeDate = GetDayTimeDate & Hour(Now) & "."
		End If
		
		If CInt(Minute(Now)) < 10 Then
			GetDayTimeDate = GetDayTimeDate & "0" & Minute(Now) & "."
		Else
			GetDayTimeDate = GetDayTimeDate & Minute(Now) & "."
		End If
		
		If CInt(Second(Now)) < 10 Then
			GetDayTimeDate = GetDayTimeDate & "0" & Second(Now)
		Else
			GetDayTimeDate = GetDayTimeDate & Second(Now)
		End If
		
		If InStr(GetDayTimeDate, "/") Then
			GetDayTimeDate = Replace(GetDayTimeDate, "/", ".")
		End If
		If InStr(GetDayTimeDate, "\") Then
			GetDayTimeDate = Replace(GetDayTimeDate, "\", ".")
		End If
		
		GetDayTimeDate = GetDayTimeDate & "_" & intMilliseconds
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Creating Date " & GetDayTimeDate
	End Function
	
	Function Random(iValue)
		'**********************************************************************************
		' Purpose : Create a random integer between 0 and i
		' Input   : integer		: iValue	: The max value
		' Return  : integer		: Random number between 0 and Input (i)
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helpers:Random"
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Creating a random integer between: 0-" & iValue
		
		'Generate seed
		Randomize
		iInt = Int(iValue * Rnd)
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Random integer is: " & iInt
		Random = iInt
	End Function
	
	Sub Terminate()
		'**********************************************************************************
		' Puropose : Terminate the script, moving log to error directory.
		'            Inform the user about the error.
		' Input    : None
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper.s:Terminate"
		
		UserLog.LogEvent ERRORL, "[" & currentSub & "] ABORT."
		WScript.quit
	End Sub
	

	Function BreakString (str, str2, length, fillSpaces) 
		'********************************************************************************
		' Purpose	: Break up a string into multiline string having a given length
		' Input   	: string	: str		: the input string
		'			  string	: str2		: the input string to append at the end
		'			  integer	: length	: the desired final length
		' 			  bool	: fillSpaces: option to fill spaces
		'********************************************************************************
		Dim currentSub : currentSub = "Class Helpers:BreakString"
		
		'fill with spaces
		ReDim aResult(0)
		
		iCnt = 0
		'process the main string
		While (Len(str) > length) 
			iWordBreak = InStrRev(str, " ", length+1)
			'force a break if no word break detected
			If (iWordBreak = 0) Then
				iWordBreak = length
			End If
			ReDim Preserve aResult(iCnt)
			aResult(iCnt) = Trim(Left(str, iWordBreak))
			str = Trim(Right(str,Len(str)-iWordBreak))
			iCnt = iCnt + 1
		Wend
		'check if the remaining string can accept the append of str2
		If (Len(str)+Len(str2)+1 >length) Then
			ReDim Preserve aResult(iCnt)
			aResult(iCnt) = str
			If (Len(Trim(str2))> 0) Then
				ReDim Preserve aResult(iCnt+1)
				If fillSpaces Then
					aResult(iCnt+1) = Space(length - Len(str2)) & str2
				Else
					aResult(iCnt+1) = str2
				End If
			End If
		Else
			ReDim Preserve aResult(iCnt)
			If fillSpaces Then
				aResult(iCnt) = str & Space(length - Len(str)- Len(str2)) & str2
			Else
				If (Len(str2) > 0) Then
					aResult(iCnt) = str & Space(1) & str2
				Else	
					aResult(iCnt) = str
				End If
			End If
		End If
		BreakString = aResult
	End Function
	
	Function BuildString (str, length)
		'********************************************************************************
		' Purpose : fill up a string with space to a given length
		' Input   : string	: str		: the input string
		'			integer : length	: the desired final length
		'********************************************************************************
		Dim currentSub : currentSub = "Class Helpers:BuildString"
		
		'fill with spaces
		iCurrentLenth = Len(str)
		str = str & Space(length - iCurrentLenth)
		
		buildString = str
	End Function

	Public Function GetTempFilename()
		'**********************************************************************************
		' Purpose : Generate e temporary file, 
		' Inputs : None
		' Output : StringArray  : ShellRun : the actual output if any
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper:GetTempFilename"
		
		GetTempFilename = oShell.ExpandEnvironmentStrings("%temp%") & oFso.GetTempName
	End Function	
	
	Public Function ShellRun(sCmd, iWinStyle, bWait, sWorkDir)
		'**********************************************************************************
		' Purpose : Execute a command, It will then execute the command in a shell, 
		'           and capture the output into a file. That file is then read in and its 
		'           contents are returned as an Array() in the value the function returns.
		' Inputs : String : sCmd : The command to execute
		'		   Integer: iWinStyle : the window style (check VBS help for values)
		'		   Bool   : bWait : Wait for execution complete and return the output
		' Output : Array  : ShellRun : the actual output if any
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper:ShellRun"
				
		sTempFile = GetTempFilename()
		On Error Resume Next 
		
		Dim sCmdOnly, sCmdPath, sCmdDrive, sCmdWorkDir
		Dim COMSPEC : COMSPEC = "%comspec% /c "
		
		UserLog.LogEvent Information, "[" & currentSub & "] Command is : ["  & sCmd  & "]" & " and Work dir is: " & sWorkDir
		
		'Switch the current dir to sWorkDir or Default to command exe dir
		If sWorkDir <> vbNullString Then
			sCmdWorkDir = sWorkDir
		Else
			'Build the %comspec% to set drive and work directory
			If InStr(sCmd,Chr(34)) = 1 Then 'command is quoted
				sCmdOnly = Left(sCmd, InStr(2,sCmd,Chr(34)))
				sCmdOnly = Replace(sCmdOnly,Chr(34),vbNullString)
			Else
				sCmdOnly = Left(sCmd, InStr(2,sCmd,Chr(32)))
				sCmdOnly = Replace(sCmdOnly,Chr(32),vbNullString)
			End If 	
			sCmdWorkDir = Left(sCmdOnly, InStrRev(sCmdOnly,"\")-1)
		End If
		
		'Build the COMSPEC
		If InStr(sCmdWorkDir,":") = 2 Then 
			'extract drive info
			sCmdDrive = Left(sCmdWorkDir, InStr(sCmdWorkDir,":"))
			COMSPEC = COMSPEC & sCmdDrive & " " & chr(38) & " "
			'extract Path info
			sCmdpath = sCmdWorkDir
			If InStr(sCmdPath,Chr(32)) > 0 Then
				sCmdPath = Chr(34) & sCmdPath & Chr(34)
			End if
			COMSPEC = COMSPEC & "cd " & sCmdPath & " " & chr(38) & " "
		End If 
				
		If bWait Then
			oShell.Run COMSPEC &  sCmd  & " > " & sTempFile, iWinStyle, true
			UserLog.LogEvent SUCCESS, "[" & currentSub & "] Command Execute (Wait): [" & COMSPEC & sCmd  & " > " & sTempFile & "]"
			If Helper.FileExists(sTempFile,False) Then
				cmdOutput = Split(oFso.OpenTextFile(sTempFile,1).ReadAll,vbCRLF)
				If Err.Number = 62 Then
					UserLog.LogEvent WARNING, "[" & currentSub & "] No Output result from Command Execute"
					'Clear error
					Err.Clear
				Else
					'Just Debug
					UserLog.LogEvent SUCCESS, "[" & currentSub & "] Command Execute has Output Results."
					For iCnt = 0 To UBound(cmdOutput)
						UserLog.LogEvent INFORMATION, "[" & currentSub & "] -" & cmdOutput(iCnt)
					Next
				End If
	
				oFso.DeleteFile sTempFile, true
			Else
				UserLog.LogEvent WARNING, "[" & currentSub & "] No Output result generated from Command Execute"
			End If  
			ShellRun = cmdOutput
		Else 
			oShell.Run COMSPEC & sCmd, iWinStyle, false
			UserLog.LogEvent SUCCESS, "[" & currentSub & "] Command Execute (No Wait): " & sCmd
			ShellRun = Array()
		End If 
			
		If Err.Number <> 0 Then
			Helper.EchoErr Err, currentSub
			'Clear error
			Err.clear
		End If
	End Function
	
End Class

Public Sub Class_Event(sSource, sEventType,ByVal bResult,ByVal values)
	'********************************************************************************
	' Purpose : Fire an event received from the child objects
	'********************************************************************************
	Dim currentSub : currentSub = "Main:Class_Event"
	
	If IsArray(values) Then
		values = Join(values,"|")
	ElseIf (values = vbNullString) Then
		values = "Null"
	End If 
	
	If (TypeName(DEBUG_CLASS_EVENTS) <> "Nothing") Then
		If (DEBUG_CLASS_EVENTS = True) Then
			WScript.Echo "EVENT FIRED [" & currentSub & "] source: " & sSource & " ; EventType:" & sEventType & " ; Result:" & bResult & " ; values:" & values
		End If
	End If 
End Sub

Sub Import (sFileName)
	'**********************************************************************************
	' Purpose : Import external file
	'**********************************************************************************
	Dim oFso, oFile
	Dim sScriptDir, sFilePath, sStreamData
	
	Set oFso		= CreateObject("Scripting.FileSystemObject")
	sScriptDir = oFso.GetParentFolderName(WScript.ScriptFullName)   
	sFilePath = oFso.BuildPath(sScriptDir,sFileName)   
	Const ForReading = 1   
	
	Set oFile = oFso.OpenTextFile(sFilePath,ForReading)   
	sStreamData = oFile.ReadAll()   
	ExecuteGlobal sStreamData   
End Sub